function varargout = DFDN(varargin)
    % DFDN MATLAB code for DFDN.fig
    %      DFDN, by itself, creates a new DFDN or raises the existing
    %      singleton*.
    %
    %      H = DFDN returns the handle to a new DFDN or the handle to
    %      the existing singleton*.
    %
    %      DFDN('CALLBACK',hObject,eventData,handles,...) calls the local
    %      function named CALLBACK in DFDN.M with the given input arguments.
    %
    %      DFDN('Property','Value',...) creates a new DFDN or raises the
    %      existing singleton*.  Starting from the left, property value pairs are
    %      applied to the GUI before DFDN_OpeningFcn gets called.  An
    %      unrecognized property name or invalid value makes property application
    %      stop.  All inputs are passed to DFDN_OpeningFcn via varargin.
    %
    %      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
    %      instance to run (singleton)".
    %
    % See also: GUIDE, GUIDATA, GUIHANDLES

    % Edit the above text to modify the response to help DFDN

    % Last Modified by GUIDE v2.5 19-Jun-2021 20:18:48

    % Begin initialization code - DO NOT EDIT
        gui_Singleton = 1;
        gui_State = struct('gui_Name',       mfilename, ...
                           'gui_Singleton',  gui_Singleton, ...
                           'gui_OpeningFcn', @DFDN_OpeningFcn, ...
                           'gui_OutputFcn',  @DFDN_OutputFcn, ...
                           'gui_LayoutFcn',  [] , ...
                           'gui_Callback',   []);
        if nargin && ischar(varargin{1})
            gui_State.gui_Callback = str2func(varargin{1});
        end

        if nargout
            [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
        else
            gui_mainfcn(gui_State, varargin{:});
        end
    % End initialization code - DO NOT EDIT
    
    %%
% Plus2.M
% This function adds two vectors of different lengths.
% (Matlab standard "+" operator doesn't work with
%  vectors of different lenghts).
% ____________________________________________________

function [vec3] = Plus2(vec1,vec2)
    len1=length(vec1);
    len2=length(vec2);
    
    if len1 < len2
       vec3(1:len1,:)=vec1(1:len1,:)+vec2(1:len1,:);
       vec3(len1+1:len2,:)=vec2(len1+1:len2,:);
    elseif len1 > len2
       vec3(1:len2,:)=vec1(1:len2,:)+vec2(1:len2,:);
       vec3(len2+1:len1,:)=vec1(len2+1:len1,:);
    else
       vec3 = vec1+vec2;
    end
    
    
    function DirectionalT60 = GetDecayTimes(grid_Cartesian, beta, alpha0)

        KN = length(grid_Cartesian);

       %% Calculate a reference point for the example shape 
        % (the point looks forward)
        azi = zeros(KN, 1);
        elev = zeros(KN, 1);
        radius = ones(KN, 1);
        look_at_point = zeros(KN, 3);
        [look_at_point(:,1),look_at_point(:,2),look_at_point(:,3)] = sph2cart(azi,elev,radius);

        % This is just a fancy function to generate different decay times, it
        % has a recongizable shape similar to a cardoid pattern
        det0 = dot(grid_Cartesian', look_at_point')';
        DirectionalT60 =  1 + (beta * alpha0 + (1-beta).*(alpha0 .* det0));


    function [T1_trunc, T2_trunc, T3_trunc, T4_trunc]  = GenerateDWM(param, delayLen, N_Line, plot_DWM)

    % Maximum gain, at all directions
    max_gT_db = -60.0 * (1.0 ./ (param.fs .* param.maxDecay/delayLen));

    % Directional gain
    target_gT_db = -60.0 * (1.0 ./ (param.fs .* param.dir_T60/delayLen));

    % Calculate the required gain for each point on the grid (max_g_db
    % should attenuate every channels)
    gT_db = target_gT_db - max_gT_db;
    gT_lin = 10.^(gT_db ./ 20.0);

    m = prime_power_delays(param.fs, N_Line, param.maxDecay);   % Delays for the late reverberation, 1*3
    gT1 = gT_lin .^ m(1); % 840*1
    gT2 = gT_lin .^ m(2); % 840*1
    gT3 = gT_lin .^ m(3); % 840*1 
    gT4 = gT_lin .^ m(4); % 840*1 


    %% Plot the 3D shape of the DWM
    if plot_DWM == 1
        filepath = 'N040_M840_Octa.dat';
        grid = loadSphGrid(filepath);
        grid.aziInc = [grid.aziElev(:,1) pi/2-grid.aziElev(:,2)];

        figure
        plotSphFunctionTriangle(10*log10(abs(g_lin)),grid.aziInc,'real')

        axis equal;
        view(0,0);
    end

    %% Construct the full DWM
    T1_full = (4*pi/param.K)*param.Y' * (diag(gT1)*param.Y(:,1:(param.order+1)^2));
    T2_full = (4*pi/param.K)*param.Y' * (diag(gT2)*param.Y(:,1:(param.order+1)^2));
    T3_full = (4*pi/param.K)*param.Y' * (diag(gT3)*param.Y(:,1:(param.order+1)^2));
    T4_full = (4*pi/param.K)*param.Y' * (diag(gT4)*param.Y(:,1:(param.order+1)^2));


    %% Truncate to the appropriate order
    T1_trunc = T1_full(1:(param.order+1)^2,:);
    T2_trunc = T2_full(1:(param.order+1)^2,:);
    T3_trunc = T3_full(1:(param.order+1)^2,:);
    T4_trunc = T4_full(1:(param.order+1)^2,:);

        


% --- Executes just before DFDN is made visible.
function DFDN_OpeningFcn(hObject, eventdata, handles, varargin)
    % This function has no output args, see OutputFcn.
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    % varargin   command line arguments to DFDN (see VARARGIN)

        % Choose default command line output for DFDN
        handles.output = hObject;
        handles.file = 'Enter full path and file name';

        % Update handles structure
        guidata(hObject, handles);

    % UIWAIT makes DFDN wait for user response (see UIRESUME)
    % uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = DFDN_OutputFcn(hObject, eventdata, handles) 
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

        % Get default command line output from handles structure
        varargout{1} = handles.output;



function File_path_Callback(hObject, eventdata, handles)
    % hObject    handle to File_path (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: get(hObject,'String') returns contents of File_path as text
    %        str2double(get(hObject,'String')) returns contents of File_path as a double
        handles.file = get(hObject, 'String');
        guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function File_path_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to File_path (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: edit controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
        if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
            set(hObject,'BackgroundColor','white');
        end


% --- Executes on button press in Open_button.
function Open_button_Callback(hObject, eventdata, handles)
    % hObject    handle to Open_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
        if (strcmp(handles.file,'Enter full path and file name')||strcmp(handles.file,'You must enter a filename first!'))
            set(handles.file_path, 'string', 'You must enter a filename first!');
        else
            [handles.audio, handles.Fs] = audioread(handles.file); 
            handles.audio = handles.audio ./ max(abs(handles.audio));

            axes(handles.Unprocessed_audio);      %set which axes to plot on
            plot(linspace(0,(length(handles.audio)-1)/handles.Fs,length(handles.audio)),handles.audio);
            title('sound');
        end
        guidata(hObject, handles);

% --- Executes on button press in Play_unprocessed_button.
function Play_unprocessed_button_Callback(hObject, eventdata, handles)
    % hObject    handle to Play_unprocessed_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
        sound(handles.audio,handles.Fs);

% --- Executes on button press in DFDN_filter_button.
function DFDN_filter_button_Callback(hObject, eventdata, handles)
    % hObject    handle to DFDN_filter_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)   
tic;

        N_Line = 4; % The number of the delay line.
        
        if (handles.RT60 == 0.266);        % Reverb time, you can change it according to your need
            Delvar = 0.01;        % Randomness in difference of L and R delays
            corr_scale = 0.238;    % Amount of channel correlation. 1 is identical left and right signals
            [RealImp, handles.Fs] = audioread('0.266s_BinauralRealImpulseResponse.wav');
            RealImp = RealImp ./ max(abs(RealImp));
            m = prime_power_delays(handles.Fs, N_Line, 3*handles.RT60);   % Delays for the late reverberation, 1*3
        elseif (handles.RT60 == 0.95)
            Delvar = 0.1;        % Randomness in difference of L and R delays
            corr_scale = 0.1829;    % Amount of channel correlation. 1 is identical left and right signals
            [RealImp, handles.Fs] = audioread('0.95s_BinauralRealImpulseResponse.wav');
            RealImp = RealImp ./ max(abs(RealImp));
            m = prime_power_delays(handles.Fs, N_Line, 4*handles.RT60);   % Delays for the late reverberation, 1*3
        elseif (handles.RT60 == 2.34)
            Delvar = 0.1;        % Randomness in difference of L and R delays
            corr_scale = 0.1007;    % Amount of channel correlation. 1 is identical left and right signals
            [RealImp, handles.Fs] = audioread('2.34s_BinauralRealImpulseResponse.wav');
            RealImp = RealImp ./ max(abs(RealImp));
            m = prime_power_delays(handles.Fs, N_Line, 5*handles.RT60);   % Delays for the late reverberation, 1*3
        end
        
        handles.HRIR_DS = 1;         % Additional flag to add a HRIR as direct sound. 

        % -------------------- Spherical harmonic for s(n) ------------------- %    
        % Load a grid of 840 points around a sphere
        filepath = 'N040_M840_Octa.dat';
        grid = loadSphGrid(filepath);
        % Convert elevation to inclination
        aziInc = [grid.aziElev(:,1) pi/2-grid.aziElev(:,2)];
        % Store the number of points
        K = grid.nPoints;
        % Maximum Ambisonics order
        Amb_order = 1;
        Amb_channel = (Amb_order + 1)^2;
        % Get the Ambisonics encoding matrix
        Y = getSH(Amb_order+1, aziInc, 'real');   % 840*9

        % -------------------- Orthogonal matrix ------------------- %      
        A_temp = hadamard(N_Line);  % 4*4
        IQ = eye(Amb_channel);
        A = kron(A_temp,IQ);    % 16*16
        % ---------------------------------------------------------- %

        % --------------------Gain and directional weighting matrix ------------------- %      
        %         % Maximum T60 time
        %         max_t60 = 5;
        % Parameters for the example shape of DT60 distribution
        beta = 0.5;
        alpha0 = handles.RT60;
        % Calculate direction dependent decay for each points
        directionalT60 = GetDecayTimes(grid.xyz, beta, alpha0);

        % Prepare structure for the DWM
        dt_param.dir_T60 = directionalT60;
        dt_param.Y = Y;
        dt_param.K = K;
        dt_param.maxDecay = max(dt_param.dir_T60);
        dt_param.minDecay = min(dt_param.dir_T60);
        dt_param.fs = handles.Fs;
        dt_param.order = Amb_order;

        g_dB = -60  ./ (handles.Fs .* handles.RT60);
        g_lin = 10 .^ (g_dB ./ 20);
        g = [g_lin .^ m(1), g_lin .^ m(2), g_lin .^ m(3), g_lin .^ m(4)];  % 1*4

        % This would be doen for each delay group in the DFDN
        plot_DWM = 0;       % Plot the shape of the DWM
        delay_length_ms = 70/1000; % generate a delay length
        [T1_trunc, T2_trunc, T3_trunc, T4_trunc] = GenerateDWM(dt_param, delay_length_ms * dt_param.fs, N_Line, plot_DWM);

        % ----------------------------------------------------------- %      

        b = ones(Amb_channel, 1);   % 4*1
        d = ones(Amb_channel, 1);   % 4*1
        c = ones(Amb_channel, 1);   % 4*1

        % -------------------- Filter ------------------- %
        imp = [1,zeros(1,round(handles.RT60 * handles.Fs))];    % 1*(length(RT60*Fs)+1)
        imp_b = b * imp;    % For an omnidirectional source, the input gain of the direct sound of the ith SH delay line is bi = [1, 0, 0,... 0], so here is a 4 channel input, 4*(RT60*Fs+1)  
        impb_SHT = (4*pi/K) * Y(:, 1:Amb_channel) * imp_b;   % Convert input into spherical hanmonic transform!!!!!!!!!!!, 840*(RT60*Fs+1) 
        impb_ISHT = Y(:, 1:Amb_channel)' * impb_SHT; % 4*(RT60*Fs+1)  

        % Matrix parallel filter
        imp_ref1 = zeros(size(impb_ISHT));
        impref1_temp = zeros(size(impb_ISHT));
        num1 = [zeros(m(1),1); g(1)];
        for i = 1 : Amb_channel
            for j = 1 : Amb_channel 
                den1 = [1; zeros(m(1)-1,1); -A(i,j).*T1_trunc(i,j).*g(1)]; 
                impref1_temp(i,:) = filter(num1, den1, impb_ISHT(i,:));
                imp_ref1(i,:) = impref1_temp(i,:) + imp_ref1(i,:);  % 4*(RT60*Fs+1)
            end
        end

        imp_c1 = imp_ref1 .* c;

        imp_ref2 = zeros(size(impb_ISHT));
        impref2_temp = zeros(size(impb_ISHT));
        num2 = [zeros(m(2),1); g(2)];
        for i = 1 : Amb_channel
            for j = 1 : Amb_channel         
                den2 = [1; zeros(m(2)-1,1); -A(i+4,j+4).*T2_trunc(i,j).*g(2)]; 
                impref2_temp(i,:) = filter(num2, den2, impb_ISHT(i,:));
                imp_ref2(i,:) = impref2_temp(i,:) + imp_ref2(i,:);  % 4*(RT60*Fs+1) 
            end
        end

        imp_c2 = imp_ref2 .* c;

        imp_ref3 = zeros(size(impb_ISHT));
        impref3_temp = zeros(size(impb_ISHT));
        num3 = [zeros(m(3),1); g(3)];
        for i = 1 : Amb_channel
            for j = 1 : Amb_channel          
                den3 = [1; zeros(m(3)-1,1); -A(i+8,j+8).*T3_trunc(i,j).*g(3)]; 
                impref3_temp(i,:) = filter(num3, den3, impb_ISHT(i,:));
                imp_ref3(i,:) = impref3_temp(i,:) + imp_ref3(i,:);  % 4*(RT60*Fs+1)    
            end
        end

        imp_c3 = imp_ref3 .* c;
        
        imp_ref4 = zeros(size(impb_ISHT));
        impref4_temp = zeros(size(impb_ISHT));
        num4 = [zeros(m(4),1); g(4)];
        for i = 1 : Amb_channel
            for j = 1 : Amb_channel          
                den4 = [1; zeros(m(4)-1,1); -A(i+8,j+8).*T4_trunc(i,j).*g(4)]; 
                impref4_temp(i,:) = filter(num4, den4, impb_ISHT(i,:));
                imp_ref4(i,:) = impref4_temp(i,:) + imp_ref4(i,:);  % 4*(RT60*Fs+1)    
            end
        end

        imp_c4 = imp_ref4 .* c;

        imp_d = d * imp;    % For an omnidirectional source, the input gain of the direct sound of the ith SH delay line is bi = [1, 0, 0,... 0], so here is a 4 channel input, 4*(length(RT60*Fs)+1)
        impd_SHT = (4*pi/K) * Y(:, 1:Amb_channel) * imp_d;   % Convert input into spherical hanmonic transform!!!!!!!!!!!, 840*(length(RT60*Fs)+1)  
        impd_ISHT = Y(:, 1:Amb_channel)' * impd_SHT; % 25*(length(RT60*Fs)+1)  

        imp_outFb = impd_ISHT + imp_c1 + imp_c2 + imp_c3 + imp_c4;

        handles.imp_out = imp_outFb';   % (RT60*Fs+1) * 4

        handles.imp_out = decodeBformat2stereo(handles.imp_out, 1, 180);    % decode Bformat to stereo in omnidirectional 
        
        %run right channel delay 
        b = [zeros(round(Delvar*handles.Fs),1);1];
        a = [1;zeros(round(Delvar*handles.Fs),1)];
        %get impulse response
        handles.imp_out(:, 2) = filter(b, a, handles.imp_out(:,2));

        handles.imp_out = Plus2(handles.imp_out,fliplr(handles.imp_out)*corr_scale); % If you want to increase channel correlation

        if handles.HRIR_DS == 0
            handles.imp_out = Plus2(handles.imp_out, imp); % Adding in direct sound here!
        else
            [HRIR, handles.Fs] = audioread('azi_0,0_ele_0,0.wav'); 
            [y, HRIR_mp] = rceps(HRIR); % Get min phase HRTF just for this example 
            handles.imp_out = Plus2(handles.imp_out, HRIR_mp); % Make direct sound a HRTF
        end

        %% Match Timbre L
        handles.imp_out_L = handles.imp_out(:,1);
        RealImp_L = RealImp(:,1);
        % Skip past direct sound, if we want to apply timbre match on reverb only.
        [m1_L, I1_L] = max(abs(handles.imp_out_L));
        [m2_L, I2_L] = max(abs(RealImp_L));

        nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

        hRev1_L = zeros(size(handles.imp_out_L)); % Initialise reverb arrays
        hRev2_L = zeros(size(RealImp_L));

        hRev1_L(I1_L+nSkipsamps:end) = handles.imp_out_L((I1_L+nSkipsamps:end)); % Reverb portion only
        hRev2_L(I2_L+nSkipsamps:end) = RealImp_L((I2_L+nSkipsamps:end));



        %% Create ERB based linear phase filterbank

        nfft = 4096;    % 2^12

        [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


        %% For each ERB band compare and match rms value
        for i = 1:size(b,1)

            hRev1filt_L = fftfilt(b(i,:), hRev1_L, nfft); % Filter IR 1
            hRev2filt_L = fftfilt(b(i,:), hRev2_L, nfft); % Filter IR 2

            dB_h1_L(i) = 20*log10(rms(hRev1filt_L)); % Compute rms average dB value
            dB_h2_L(i) = 20*log10(rms(hRev2filt_L)); 
            dB_diff_L(i) = dB_h2_L(i)-dB_h1_L(i); % Estimate difference in dB       


            hout_L(i,:) = hRev1filt_L*db2mag(dB_diff_L(i)); % Scale IR 1 by difference

            dB_hout_L(i) = 20*log10(rms(hout_L(i,:))); % Compute rms average dB value for output reverb
        end


        %% Sum bands and add direct sound back in
        hout_L = sum(hout_L)';
        % Remove offset
        hout_L = hout_L(nfft/2+1:end);

        Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
        hout_L_Fout(1:I1_L+nSkipsamps) = [handles.imp_out_L(1:I1_L+nSkipsamps-nSkipsamps/2); handles.imp_out_L(I1_L+nSkipsamps-nSkipsamps/2+1:I1_L+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
        hout_L_FIn(1:I1_L+nSkipsamps) = [hout_L(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_L(nSkipsamps/2+1:I1_L+nSkipsamps)];   % Fade in Hanning windows
        hout_L(1:I1_L+nSkipsamps) = hout_L_Fout(1:I1_L+nSkipsamps) + hout_L_FIn(1:I1_L+nSkipsamps);    % Add fade out and fade in

        % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


        %% Plot the results
        % 'IR1 Scaled' should now give the same average spectrum as IR2.

        figure()
        plot(dB_h1_L);
        hold on
        plot(dB_h2_L, 'r');
        plot(dB_diff_L, 'k:');
        plot(dB_hout_L, 'go');
        legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
        xlabel('ERB band');
        ylabel('dB');
        title('dB_{rms} of impulse responses and ERB difference (L channel)');


        %% Match Timbre R
        handles.imp_out_R = handles.imp_out(:,2);
        RealImp_R = RealImp(:,2);
        % Skip past direct sound, if we want to apply timbre match on reverb only.
        [m1_R, I1_R] = max(abs(handles.imp_out_R));
        [m2_R, I2_R] = max(abs(RealImp_R));

        nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

        hRev1_R = zeros(size(handles.imp_out_R)); % Initialise reverb arrays
        hRev2_R = zeros(size(RealImp_R));

        hRev1_R(I1_R+nSkipsamps:end) = handles.imp_out_R((I1_R+nSkipsamps:end)); % Reverb portion only
        hRev2_R(I2_R+nSkipsamps:end) = RealImp_R((I2_R+nSkipsamps:end));



        %% Create ERB based linear phase filterbank

        nfft = 4096;    % 2^12

        [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


        %% For each ERB band compare and match rms value
        for i = 1:size(b,1)

            hRev1filt_R = fftfilt(b(i,:), hRev1_R, nfft); % Filter IR 1
            hRev2filt_R = fftfilt(b(i,:), hRev2_R, nfft); % Filter IR 2

            dB_h1_R(i) = 20*log10(rms(hRev1filt_R)); % Compute rms average dB value
            dB_h2_R(i) = 20*log10(rms(hRev2filt_R)); 
            dB_diff_R(i) = dB_h2_R(i)-dB_h1_R(i); % Estimate difference in dB       


            hout_R(i,:) = hRev1filt_R*db2mag(dB_diff_R(i)); % Scale IR 1 by difference

            dB_hout_R(i) = 20*log10(rms(hout_R(i,:))); % Compute rms average dB value for output reverb


        end


        %% Sum bands and add direct sound back in
        hout_R = sum(hout_R)';
        % Remove offset
        hout_R = hout_R(nfft/2+1:end);

        Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
        hout_R_Fout(1:I1_R+nSkipsamps) = [handles.imp_out_R(1:I1_R+nSkipsamps-nSkipsamps/2); handles.imp_out_R(I1_R+nSkipsamps-nSkipsamps/2+1:I1_R+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
        hout_R_FIn(1:I1_R+nSkipsamps) = [hout_R(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_R(nSkipsamps/2+1:I1_R+nSkipsamps)];   % Fade in Hanning windows
        hout_R(1:I1_R+nSkipsamps) = hout_R_Fout(1:I1_R+nSkipsamps) + hout_R_FIn(1:I1_R+nSkipsamps);    % Add fade out and fade in

        % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


        %% Plot the results
        % 'IR1 Scaled' should now give the same average spectrum as IR2.

        figure()
        plot(dB_h1_R);
        hold on
        plot(dB_h2_R, 'r');
        plot(dB_diff_R, 'k:');
        plot(dB_hout_R, 'go');
        legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
        xlabel('ERB band');
        ylabel('dB');
        title('dB_{rms} of impulse responses and ERB difference (R channel)');

        handles.imp_out = [hout_L, hout_R];   % Combine left and right channel

        C = round(0.0025 * handles.Fs); 
        [m, I] = max(abs(handles.imp_out));
        if (min(I) - C <= 0)
            handles.imp_out = [zeros(C-min(I)+1, 2); handles.imp_out];  
        end
        [m, I] = max(abs(handles.imp_out));
        Direct = handles.imp_out(I-C: I+C, :); 
        Reverb = handles.imp_out(I+C+1: end, :);

        DRR_orig = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

        handles.imp_out(I+C+1:end,:) = (handles.imp_out(I+C+1:end,:)*DRR_orig)/handles.DRR; % Scale reverb for desired DRR;

        Direct = handles.imp_out(I-C: I+C, :); 
        Reverb = handles.imp_out(I+C+1: end, :);

        DRR_final = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

        imp_final_L = handles.imp_out(:, 1);
        imp_final_R = handles.imp_out(:, 2);

        %% Compute IACC
        maxlags = round(0.001*handles.Fs); % Maximum lag for correlation (cross head delay)
        [IACC] = max(abs(xcorr(imp_final_L, imp_final_R, maxlags, 'normalized' )))
        
        %normalise the output
        handles.imp_out = handles.imp_out ./ max(abs(handles.imp_out));        

        N = length(handles.audio)+length(handles.imp_out)-1;	%confirm the length of FFT
        L = pow2(nextpow2(N));	%confirm the length of 2FFT
        X = fft(handles.audio,L);
        H = fft(handles.imp_out,L);
        Y = X .* H;
        handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution

        handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
        
        disp(num2str(toc));
        
        plotFigure(handles.imp_out,handles.Fs) 
        
        %calculate frequency response
        %set FFT size to be power of 2 which is greater than the length of a or b
        power_of_2=1;
        while ((2^power_of_2) < max(m))
            power_of_2 = power_of_2 + 1;
        end
        % Calculate the frequncy spectrum for these filter coefficients ...
        % (Note that there could be aliasing if the FFT length is too small
        % with respect to the plotting number of points. Therefore need to
        % increase the length, which pads with zeros) but still a power of 2.
        if (power_of_2 < 10)
            power_of_2 = 10;
        end

        %display impulse response
        axes(handles.Impulse_response); %set which axis to plot on
        plot(linspace(0,(length(handles.imp_out)-1)/handles.Fs,length(handles.imp_out)),handles.imp_out);
        title('DFDN impulse response (x axis in s)');

        %display processed waveform
        axes(handles.Processed_audio); %set which axes to plot on
        plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    %     plot(T,handles.processed_audio);
        title('DFDN filter (x axis in s)');
        %Set coordinate parameters (Insert ITDG)
    %     v = axis;
    %     v(1) = 0;
    %     v(2) = 3;        %Set scale of x axis
    %     axis(v);

        %return a frequency vector to give the x axis in Hz
        H = fft(handles.imp_out,2^power_of_2);
        %get magnitude of complex output
        gain = abs(H);

        %plot frequency response
        axes(handles.Frequency_response); %set which axis to plot on  
        n = 0 : 2^power_of_2 - 1;
        F = n*handles.Fs/2^power_of_2;    %frequency sequence
        plot(F,gain);
        title('DFDN frequency response (x axis in Hz)');

        %update handles  
        guidata(hObject, handles);
        


function Save_path_Callback(hObject, eventdata, handles)
    % hObject    handle to Save_path (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: get(hObject,'String') returns contents of Save_path as text
    %        str2double(get(hObject,'String')) returns contents of Save_path as a double
        handles.save = get(hObject, 'String');
        guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Save_path_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to Save_path (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: edit controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
        if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
            set(hObject,'BackgroundColor','white');
        end


% --- Executes on button press in Play_processed_button.
function Play_processed_button_Callback(hObject, eventdata, handles)
    % hObject    handle to Play_processed_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
        sound(handles.processed_audio, handles.Fs);

% --- Executes on button press in Save_file_button.
function Save_file_button_Callback(hObject, eventdata, handles)
    % hObject    handle to Save_file_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
        audiowrite(handles.save,handles.processed_audio,handles.Fs);
%         audiowrite(handles.save,handles.imp_all,handles.Fs);
        guidata(hObject, handles);



function RT60_Callback(hObject, eventdata, handles)
    % hObject    handle to RT60 (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: get(hObject,'String') returns contents of RRT60 as text
    %        str2double(get(hObject,'String')) returns contents of RRT60 as a double
        handles.RT60 = str2double(get(hObject, 'String'));
        if isnan(handles.RT60)
        errordlg('You must enter a numeric value','Bad Input','modal')
        end
        guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function RT60_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to RT60 (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: edit controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
        if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
            set(hObject,'BackgroundColor','white');
        end


function DRR_Callback(hObject, eventdata, handles)
    % hObject    handle to DRR (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: get(hObject,'String') returns contents of DRR as text
    %        str2double(get(hObject,'String')) returns contents of DRR as a double
    handles.DRR = str2double(get(hObject,'string'));
    if isnan(handles.DRR)
        errordlg('You must enter a numeric value','Bad Input','modal')
    end
    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function DRR_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to DRR (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: edit controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
