function m = prime_power_delays(fs, N, RT60)
    Np = N ;
    i = (1:Np) ;
    prime = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131] ;
    
    M_min = ceil(0.15*fs*RT60)
    % Approximate desired delay-line lengths using powers of distinct primes
    d(i) = ceil((M_min/Np)+(i-1).*M_min/(Np*5))
    ppwr = round(log(d(i))./log(prime(i)))
    m = prime(1:Np).^ppwr % Each delay a power of a distinct prime
    while (sum(m)< M_min)
        ppwr(1) = ppwr(1) + 1
        m = prime(1:Np).^ppwr % Each delay a power of a distinct prime
    end
end