function varargout = Gardner(varargin)
% GARDNER MATLAB code for Gardner.fig
%      GARDNER, by itself, creates a new GARDNER or raises the existing
%      singleton*.
%
%      H = GARDNER returns the handle to a new GARDNER or the handle to
%      the existing singleton*.
%
%      GARDNER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GARDNER.M with the given input arguments.
%
%      GARDNER('Property','Value',...) creates a new GARDNER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Gardner_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Gardner_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Gardner

% Last Modified by GUIDE v2.5 19-Jun-2021 19:37:21

% Begin initialization code - DO NOT EDIT
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                       'gui_Singleton',  gui_Singleton, ...
                       'gui_OpeningFcn', @Gardner_OpeningFcn, ...
                       'gui_OutputFcn',  @Gardner_OutputFcn, ...
                       'gui_LayoutFcn',  [] , ...
                       'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
% End initialization code - DO NOT EDIT

%%
% Plus2.M
% This function adds two vectors of different lengths.
% (Matlab standard "+" operator doesn't work with
%  vectors of different lenghts).
% ____________________________________________________

function [vec3] = Plus2(vec1,vec2)
    len1=length(vec1);
    len2=length(vec2);
    
    if len1 < len2
       vec3(1:len1,:)=vec1(1:len1,:)+vec2(1:len1,:);
       vec3(len1+1:len2,:)=vec2(len1+1:len2,:);
    elseif len1 > len2
       vec3(1:len2,:)=vec1(1:len2,:)+vec2(1:len2,:);
       vec3(len2+1:len1,:)=vec1(len2+1:len1,:);
    else
       vec3 = vec1+vec2;
    end

% --- Executes just before Gardner is made visible.
function Gardner_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Gardner (see VARARGIN)

% Choose default command line output for Gardner
    handles.output = hObject;
    handles.file = 'Enter full path and file name';
    
    

% Update handles structure
    guidata(hObject, handles);

% UIWAIT makes Gardner wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Gardner_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
    varargout{1} = handles.output;



function File_path_Callback(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of File_path as text
%        str2double(get(hObject,'String')) returns contents of File_path as a double
    handles.file = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function File_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Open_button.
function Open_button_Callback(hObject, eventdata, handles)
% hObject    handle to Open_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    if (strcmp(handles.file,'Enter full path and file name')||strcmp(handles.file,'You must enter a filename first!'))
        set(handles.file_path, 'string', 'You must enter a filename first!');
    else
        [handles.audio, handles.Fs] = audioread(handles.file); 
        axes(handles.Unprocessed_audio);      %set which axes to plot on
        plot(linspace(0,(length(handles.audio)-1)/handles.Fs,length(handles.audio)),handles.audio);
        title('sound');
        xlabel('Time (s)');
        ylabel('Amplitude');
    end
    guidata(hObject, handles);

% --- Executes on button press in Play_unprocessed_button.
function Play_unprocessed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_unprocessed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.audio,handles.Fs);


function RT60_input_Callback(hObject, ~, handles)
% hObject    handle to RT60_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of RT60_input as text
%        str2double(get(hObject,'String')) returns contents of RT60_input as a double
    handles.RT60_input = str2double(get(hObject, 'String'));
    if isnan(handles.RT60_input)
    errordlg('You must enter a numeric value','Bad Input','modal')
    end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function RT60_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RT60_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Gardner_large_button.
function Gardner_large_button_Callback(hObject, eventdata, handles)
% hObject    handle to Gardner_large_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA) 
tic;
    Delvar = 0.1;        % Randomness in difference of L and R delays
    corr_scale = 0.2446;    % Amount of channel correlation. 1 is identical left and right signals
    handles.HRIR_DS = 1;         % Additional flag to add a HRIR as direct sound. 
    [RealImp, handles.Fs] = audioread('2.34s_BinauralRealImpulseResponse.wav');
    RealImp = RealImp ./ max(abs(RealImp));
    
    %---------------Left channel--------------%
    %set filter parameters
    handles.LP_gain = 0.6;
    handles.A1_gain = 0.3;
    handles.A2_gain = 0.3;
    handles.SNAO_gain = 0.5;
    handles.SNAI_gain = 0.25;
    handles.DNAO_gain = 0.5;
    handles.DNAI1_gain = 0.25;
    handles.DNAI2_gain = 0.25;
    handles.gain = 0.34;
    handles.L_gain = 1/2600;
    
    handles.temp = 15;
    handles.A1_delay = round(8 * handles.temp);
    handles.A2_delay = round(12 * handles.temp);
    handles.delay1 = round(4 * handles.temp);
    handles.delay2 = round(17 * handles.temp);
    handles.SNAO_delay = round(87 * handles.temp);
    handles.SNAI_delay = round(62 * handles.temp);
    handles.delay3 = round(31 * handles.temp);
    handles.delay4 = round(3 * handles.temp);
    handles.DNAO_delay = round(120 * handles.temp);
    handles.DNAI1_delay = round(76 * handles.temp);
    handles.DNAI2_delay = round(30 * handles.temp);
    
    delay_G = handles.A1_delay+handles.A2_delay+handles.delay1+handles.delay2+handles.SNAO_delay+handles.SNAI_delay+handles.delay3+handles.delay4+handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay;
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/(0.5*handles.RT60_input));

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function   
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv([-handles.A1_gain;zeros(handles.A1_delay-1,1);1],[-handles.A2_gain;zeros(handles.A2_delay-1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay2,1);1]);
    bref1 = conv(bref1,brefSN);
    bref1 = conv(bref1,[zeros(handles.delay3,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay4,1);1]);
    bref1 = conv(bref1,brefDN);   
    bref1 = conv(bref1,[1-handles.L_gain;zeros(round(handles.L_gain *handles.Fs),1)]);
    aref1 = conv([1;zeros(handles.A1_delay-1,1);-handles.A1_gain],[1;zeros(handles.A2_delay-1,1);-handles.A2_gain]);
    aref1 = conv(aref1,arefSN);
    aref1 = conv(aref1,arefDN);
    aref1 = conv(aref1,[1;-handles.L_gain;zeros(round(handles.gain * handles.Fs)-1,1)]);
    
    bref = aref1;
    aref = Plus2(aref1,-Gain_input*bref1);

    %Compute lowpass transfer function
    b = [1-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs),1)];
    a = [1;-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs)-1,1)];
    %get impulse response
    imp_LP = filter(b,a,imp);

    %get impulse response
    imp_ref = filter(bref,aref,imp_LP);
    
    %run allpass filter 1
    b = [-handles.A1_gain;zeros(handles.A1_delay-1,1);1];
    a = [1;zeros(handles.A1_delay-1,1);-handles.A1_gain];
    %get impulse response
    imp_A1 = filter(b,a,imp_ref);
    
    %run allpass filter 2
    b = [-handles.A2_gain;zeros(handles.A2_delay-1,1);1];
    a = [1;zeros(handles.A2_delay-1,1);-handles.A2_gain];
    %get impulse response
    imp_A2 = filter(b,a,imp_A1);
    
    %run delay 1
    b = [zeros(handles.delay1,1);1];
    a = [1;zeros(handles.delay1,1)];
    %get impulse response
    imp_D1 = filter(b,a,imp_A2);
    
    %run delay 2
    b = [zeros(handles.delay2,1);1];
    a = [1;zeros(handles.delay2,1)];
    %get impulse response
    imp_D2 = filter(b,a,imp_D1);
    
    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,imp_D2);
    
    %run delay 3
    b = [zeros(handles.delay3,1);1];
    a = [1;zeros(handles.delay3,1)];
    %get impulse response
    imp_D3 = filter(b,a,imp_SNA);
    
    %run delay 4
    b = [zeros(handles.delay4,1);1];
    a = [1;zeros(handles.delay4,1)];
    %get impulse response
    imp_D4 = filter(b,a,imp_D3);
    
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_D4);
    
    %get impulse response
    handles.imp_out_L = Plus2(handles.gain*imp_D1,handles.gain*imp_D3);
    handles.imp_out_L = Plus2(handles.imp_out_L,handles.gain*imp_DNA);
    %---------------Right channel--------------%
    
    %set filter parameters
    handles.LP_gain = 0.6;
    handles.A1_gain = 0.3;
    handles.A2_gain = 0.3;
    handles.SNAO_gain = 0.5;
    handles.SNAI_gain = 0.25;
    handles.DNAO_gain = 0.5;
    handles.DNAI1_gain = 0.25;
    handles.DNAI2_gain = 0.25;
    handles.gain = 0.34;
    handles.L_gain = 1/2600;
    
    handles.temp = 15;
    handles.A1_delay = round(8 * handles.temp * (1 + Delvar));
    handles.A2_delay = round(12 * handles.temp * (1 + Delvar));
    handles.delay1 = round(4 * handles.temp * (1 + Delvar));
    handles.delay2 = round(17 * handles.temp * (1 + Delvar));
    handles.SNAO_delay = round(87 * handles.temp * (1 + Delvar));
    handles.SNAI_delay = round(62 * handles.temp * (1 + Delvar));
    handles.delay3 = round(31 * handles.temp * (1 + Delvar));
    handles.delay4 = round(3 * handles.temp * (1 + Delvar));
    handles.DNAO_delay = round(120 * handles.temp * (1 + Delvar));
    handles.DNAI1_delay = round(76 * handles.temp * (1 + Delvar));
    handles.DNAI2_delay = round(30 * handles.temp * (1 + Delvar));
    
    delay_G = (handles.A1_delay+handles.A2_delay+handles.delay1+handles.delay2+handles.SNAO_delay+handles.SNAI_delay+handles.delay3+handles.delay4+handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay)  * (1 + Delvar);
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/(0.5*handles.RT60_input));

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function   
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv([-handles.A1_gain;zeros(handles.A1_delay-1,1);1],[-handles.A2_gain;zeros(handles.A2_delay-1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay2,1);1]);
    bref1 = conv(bref1,brefSN);
    bref1 = conv(bref1,[zeros(handles.delay3,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay4,1);1]);
    bref1 = conv(bref1,brefDN);   
    bref1 = conv(bref1,[1-handles.L_gain;zeros(round(handles.L_gain *handles.Fs),1)]);
    aref1 = conv([1;zeros(handles.A1_delay-1,1);-handles.A1_gain],[1;zeros(handles.A2_delay-1,1);-handles.A2_gain]);
    aref1 = conv(aref1,arefSN);
    aref1 = conv(aref1,arefDN);
    aref1 = conv(aref1,[1;-handles.L_gain;zeros(round(handles.gain * handles.Fs)-1,1)]);
    
    bref = aref1;
    aref = Plus2(aref1,-Gain_input*bref1);

    %Compute lowpass transfer function
    b = [1-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs),1)];
    a = [1;-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs)-1,1)];
    %get impulse response
    imp_LP = filter(b,a,imp);

    %get impulse response
    imp_ref = filter(bref,aref,imp_LP);
    
    %run allpass filter 1
    b = [-handles.A1_gain;zeros(handles.A1_delay-1,1);1];
    a = [1;zeros(handles.A1_delay-1,1);-handles.A1_gain];
    %get impulse response
    imp_A1 = filter(b,a,imp_ref);
    
    %run allpass filter 2
    b = [-handles.A2_gain;zeros(handles.A2_delay-1,1);1];
    a = [1;zeros(handles.A2_delay-1,1);-handles.A2_gain];
    %get impulse response
    imp_A2 = filter(b,a,imp_A1);
    
    %run delay 1
    b = [zeros(handles.delay1,1);1];
    a = [1;zeros(handles.delay1,1)];
    %get impulse response
    imp_D1 = filter(b,a,imp_A2);
    
    %run delay 2
    b = [zeros(handles.delay2,1);1];
    a = [1;zeros(handles.delay2,1)];
    %get impulse response
    imp_D2 = filter(b,a,imp_D1);
    
    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,imp_D2);
    
    %run delay 3
    b = [zeros(handles.delay3,1);1];
    a = [1;zeros(handles.delay3,1)];
    %get impulse response
    imp_D3 = filter(b,a,imp_SNA);
    
    %run delay 4
    b = [zeros(handles.delay4,1);1];
    a = [1;zeros(handles.delay4,1)];
    %get impulse response
    imp_D4 = filter(b,a,imp_D3);
    
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_D4);
    
    %get impulse response
    handles.imp_out_R = Plus2(handles.gain*imp_D1,handles.gain*imp_D3);
    handles.imp_out_R = Plus2(handles.imp_out_R,handles.gain*imp_DNA);
    
    handles.imp_out = [handles.imp_out_L, handles.imp_out_R]; 

    handles.imp_out = Plus2(handles.imp_out,fliplr(handles.imp_out)*corr_scale); % If you want to increase channel correlation

    if handles.HRIR_DS == 0
        handles.imp_out = Plus2(handles.imp_out, imp); % Adding in direct sound here!
    else
        [HRIR, ~] = audioread('azi_0,0_ele_0,0.wav'); 
        [~, HRIR_mp] = rceps(HRIR); % Get min phase HRTF just for this example 
        handles.imp_out = Plus2(handles.imp_out, HRIR_mp); % Make direct sound a HRTF
    end

    %% Match Timbre L
    handles.imp_out_L = handles.imp_out(:,1);
    RealImp_L = RealImp(:,1);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_L, I1_L] = max(abs(handles.imp_out_L));
    [m2_L, I2_L] = max(abs(RealImp_L));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_L = zeros(size(handles.imp_out_L)); % Initialise reverb arrays
    hRev2_L = zeros(size(RealImp_L));

    hRev1_L(I1_L+nSkipsamps:end) = handles.imp_out_L((I1_L+nSkipsamps:end)); % Reverb portion only
    hRev2_L(I2_L+nSkipsamps:end) = RealImp_L((I2_L+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_L = fftfilt(b(i,:), hRev1_L, nfft); % Filter IR 1
        hRev2filt_L = fftfilt(b(i,:), hRev2_L, nfft); % Filter IR 2

        dB_h1_L(i) = 20*log10(rms(hRev1filt_L)); % Compute rms average dB value
        dB_h2_L(i) = 20*log10(rms(hRev2filt_L)); 
        dB_diff_L(i) = dB_h2_L(i)-dB_h1_L(i); % Estimate difference in dB       


        hout_L(i,:) = hRev1filt_L*db2mag(dB_diff_L(i)); % Scale IR 1 by difference

        dB_hout_L(i) = 20*log10(rms(hout_L(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_L = sum(hout_L)';
    % Remove offset
    hout_L = hout_L(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_L_Fout(1:I1_L+nSkipsamps) = [handles.imp_out_L(1:I1_L+nSkipsamps-nSkipsamps/2); handles.imp_out_L(I1_L+nSkipsamps-nSkipsamps/2+1:I1_L+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_L_FIn(1:I1_L+nSkipsamps) = [hout_L(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_L(nSkipsamps/2+1:I1_L+nSkipsamps)];   % Fade in Hanning windows
    hout_L(1:I1_L+nSkipsamps) = hout_L_Fout(1:I1_L+nSkipsamps) + hout_L_FIn(1:I1_L+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_L);
    hold on
    plot(dB_h2_L, 'r');
    plot(dB_diff_L, 'k:');
    plot(dB_hout_L, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (L channel)');


    %% Match Timbre R
    handles.imp_out_R = handles.imp_out(:,2);
    RealImp_R = RealImp(:,2);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_R, I1_R] = max(abs(handles.imp_out_R));
    [m2_R, I2_R] = max(abs(RealImp_R));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_R = zeros(size(handles.imp_out_R)); % Initialise reverb arrays
    hRev2_R = zeros(size(RealImp_R));

    hRev1_R(I1_R+nSkipsamps:end) = handles.imp_out_R((I1_R+nSkipsamps:end)); % Reverb portion only
    hRev2_R(I2_R+nSkipsamps:end) = RealImp_R((I2_R+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_R = fftfilt(b(i,:), hRev1_R, nfft); % Filter IR 1
        hRev2filt_R = fftfilt(b(i,:), hRev2_R, nfft); % Filter IR 2

        dB_h1_R(i) = 20*log10(rms(hRev1filt_R)); % Compute rms average dB value
        dB_h2_R(i) = 20*log10(rms(hRev2filt_R)); 
        dB_diff_R(i) = dB_h2_R(i)-dB_h1_R(i); % Estimate difference in dB       


        hout_R(i,:) = hRev1filt_R*db2mag(dB_diff_R(i)); % Scale IR 1 by difference

        dB_hout_R(i) = 20*log10(rms(hout_R(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_R = sum(hout_R)';
    % Remove offset
    hout_R = hout_R(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_R_Fout(1:I1_R+nSkipsamps) = [handles.imp_out_R(1:I1_R+nSkipsamps-nSkipsamps/2); handles.imp_out_R(I1_R+nSkipsamps-nSkipsamps/2+1:I1_R+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_R_FIn(1:I1_R+nSkipsamps) = [hout_R(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_R(nSkipsamps/2+1:I1_R+nSkipsamps)];   % Fade in Hanning windows
    hout_R(1:I1_R+nSkipsamps) = hout_R_Fout(1:I1_R+nSkipsamps) + hout_R_FIn(1:I1_R+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_R);
    hold on
    plot(dB_h2_R, 'r');
    plot(dB_diff_R, 'k:');
    plot(dB_hout_R, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (R channel)');

    handles.imp_out = [hout_L, hout_R];   % Combine left and right channel    
    
    C = round(0.0025 * handles.Fs); 
    [m, I] = max(abs(handles.imp_out));
    if (min(I) - C <= 0)
        handles.imp_out = [zeros(C-min(I)+1, 2); handles.imp_out];  
    end
    [m, I] = max(abs(handles.imp_out));
    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_orig = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_out(I+C+1:end,:) = (handles.imp_out(I+C+1:end,:)*DRR_orig)/handles.DRR; % Scale reverb for desired DRR;

    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_final = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_final_L = handles.imp_out(:, 1);
    handles.imp_final_R = handles.imp_out(:, 2);

    %% Compute IACC
    maxlags = round(0.001 * handles.Fs); % Maximum lag for correlation (cross head delay)
    [IACC] = max(abs(xcorr(handles.imp_final_L, handles.imp_final_R, maxlags, 'normalized' )))
    
    %normalise the output
    handles.imp_out = handles.imp_out ./ max(abs(handles.imp_out));
  
    N = length(handles.audio)+length(handles.imp_out)-1;	%confirm the length of FFT
    L = pow2(nextpow2(N));	%confirm the length of 2FFT
    X = fft(handles.audio,L);
    H = fft(handles.imp_out,L);
    Y = X .* H;
    handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
     
    disp(num2str(toc));
    
    plotFigure(handles.imp_out,handles.Fs)
    
    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(handles.imp_out)-1)/handles.Fs,length(handles.imp_out)),handles.imp_out);
    title('Large room impulse response');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('Large room Gardner filter');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < handles.DNAO_delay)
        power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
        power_of_2 = 10;
    end
    
    %return a frequency vector to give the x axis in Hz
    H = fft(handles.imp_out,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('Large room frequency response');
    xlabel('Frequency (Hz)');
    ylabel('Amplitude');
    
    %update handles  
    guidata(hObject, handles);

% --- Executes on button press in Play_processed_button.
function Play_processed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_processed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.processed_audio, handles.Fs);
    

function Save_path_Callback(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Save_path as text
%        str2double(get(hObject,'String')) returns contents of Save_path as a double
    handles.save = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Save_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Save_button.
function Save_button_Callback(hObject, eventdata, handles)
% hObject    handle to Save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    audiowrite(handles.save,handles.processed_audio,handles.Fs);
    guidata(hObject, handles);


% --- Executes on button press in Gardner_medium_button.
function Gardner_medium_button_Callback(hObject, eventdata, handles)
% hObject    handle to Gardner_medium_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA) 
tic;
    Delvar = 0.1;        % Randomness in difference of L and R delays
    corr_scale = 0.1645;    % Amount of channel correlation. 1 is identical left and right signals
    handles.HRIR_DS = 1;         % Additional flag to add a HRIR as direct sound. 
    [RealImp, handles.Fs] = audioread('0.95s_BinauralRealImpulseResponse.wav');
    RealImp = RealImp ./ max(abs(RealImp));
    
    %set filter parameters
    handles.DNAO_gain = 0.3;
    handles.DNAI1_gain = 0.7;
    handles.DNAI2_gain = 0.5;
    handles.A_gain = 0.5;
    handles.SNAO_gain = 0.3;
    handles.SNAI_gain = 0.6;
    handles.gain = 0.5;
    handles.L_gain = 1/2500;
    handles.gain_add = 1;
    
    handles.temp = 15;
    handles.DNAO_delay = round(35 * handles.temp);
    handles.DNAI1_delay = round(8.3 * handles.temp);
    handles.DNAI2_delay = round(22 * handles.temp);
    handles.delay1 = round(5 * handles.temp);
    handles.A_delay = round(30 * handles.temp);
    handles.delay2 = round(67 * handles.temp);
    handles.delay3 = round(15 * handles.temp);
    handles.SNAO_delay = round(39 * handles.temp);
    handles.SNAI_delay = round(9.8 * handles.temp); 
    handles.delay4 = round(108 * handles.temp);
    
    delay_G = handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay+handles.delay1+handles.A_delay+handles.delay2+handles.delay3+handles.SNAO_delay+handles.SNAI_delay+handles.delay4;
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/(1.8*handles.RT60_input));

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv(brefDN,[zeros(handles.delay1,1);1]);
    bref1 = conv(bref1,[-handles.A_gain;zeros(handles.A_delay-1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay2,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay3,1);1]);
    aref1 = conv(arefDN,[1;zeros(handles.A_delay-1,1);-handles.A_gain]);
    
    bref2 = conv(brefSN,[zeros(handles.delay4,1);1]);
    bref2 = conv(bref2,[1-handles.L_gain;zeros(round(handles.L_gain*handles.Fs),1)]);
    aref2 = conv(arefSN,[1;-handles.L_gain;zeros(round(handles.L_gain*handles.Fs)-1,1)]);
    
    breff = conv(bref2,bref2);
    breff = conv(breff,aref1);
    brefb = conv(bref2,aref2);
    brefb = conv(brefb,aref1);
    areff = conv(aref2,aref2);
    areff = conv(areff,aref1);
    arefb = conv(aref2,bref2);
    arefb = conv(arefb,bref1);
    
    bref = Plus2(breff,Gain_input*brefb);
    aref = Plus2(areff,-Gain_input^2*arefb);

    %get impulse response
    imp_ref = filter(bref,aref,imp);
   
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_ref);
    
    %run delay 1
    b = [zeros(handles.delay1,1);1];
    a = [1;zeros(handles.delay1,1)];
    %get impulse response
    imp_D1 = filter(b,a,imp_DNA);
    
    %run allpass filter 
    b = [-handles.A_gain;zeros(handles.A_delay-1,1);1];
    a = [1;zeros(handles.A_delay-1,1);-handles.A_gain];
    %get impulse response
    imp_A = filter(b,a,imp_D1);

    %run delay 2
    b = [zeros(handles.delay2,1);1];
    a = [1;zeros(handles.delay2,1)];
    %get impulse response
    imp_D2 = filter(b,a,imp_A);
    
    %run delay 3
    b = [zeros(handles.delay3,1);1];
    a = [1;zeros(handles.delay3,1)];
    %get impulse response
    imp_D3 = filter(b,a,imp_D2);
    
    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,Gain_input*imp_D3+handles.gain_add*imp);
     
    %get impulse response
    handles.imp_out_L = Plus2(handles.gain*imp_DNA,handles.gain*imp_D2);
    handles.imp_out_L = Plus2(handles.imp_out_L,handles.gain*imp_SNA);

    %---------------Right channel--------------%
    %set filter parameters
    handles.DNAO_gain = 0.3;
    handles.DNAI1_gain = 0.7;
    handles.DNAI2_gain = 0.5;
    handles.A_gain = 0.5;
    handles.SNAO_gain = 0.3;
    handles.SNAI_gain = 0.6;
    handles.gain = 0.5;
    handles.L_gain = 1/2500;
    handles.gain_add = 1;
    
    handles.temp = 15;
    handles.DNAO_delay = round(35 * handles.temp * (1 + Delvar));
    handles.DNAI1_delay = round(8.3 * handles.temp * (1 + Delvar));
    handles.DNAI2_delay = round(22 * handles.temp * (1 + Delvar));
    handles.delay1 = round(5 * handles.temp * (1 + Delvar));
    handles.A_delay = round(30 * handles.temp * (1 + Delvar));
    handles.delay2 = round(67 * handles.temp * (1 + Delvar));
    handles.delay3 = round(15 * handles.temp * (1 + Delvar));
    handles.SNAO_delay = round(39 * handles.temp * (1 + Delvar));
    handles.SNAI_delay = round(9.8 * handles.temp * (1 + Delvar)); 
    handles.delay4 = round(108 * handles.temp * (1 + Delvar));
    
    delay_G = (handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay+handles.delay1+handles.A_delay+handles.delay2+handles.delay3+handles.SNAO_delay+handles.SNAI_delay+handles.delay4) * (1 + Delvar);
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/(1.8*handles.RT60_input));

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv(brefDN,[zeros(handles.delay1,1);1]);
    bref1 = conv(bref1,[-handles.A_gain;zeros(handles.A_delay-1,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay2,1);1]);
    bref1 = conv(bref1,[zeros(handles.delay3,1);1]);
    aref1 = conv(arefDN,[1;zeros(handles.A_delay-1,1);-handles.A_gain]);
    
    bref2 = conv(brefSN,[zeros(handles.delay4,1);1]);
    bref2 = conv(bref2,[1-handles.L_gain;zeros(round(handles.L_gain*handles.Fs),1)]);
    aref2 = conv(arefSN,[1;-handles.L_gain;zeros(round(handles.L_gain*handles.Fs)-1,1)]);
    
    breff = conv(bref2,bref2);
    breff = conv(breff,aref1);
    brefb = conv(bref2,aref2);
    brefb = conv(brefb,aref1);
    areff = conv(aref2,aref2);
    areff = conv(areff,aref1);
    arefb = conv(aref2,bref2);
    arefb = conv(arefb,bref1);
    
    bref = Plus2(breff,Gain_input*brefb);
    aref = Plus2(areff,-Gain_input^2*arefb);

    %get impulse response
    imp_ref = filter(bref,aref,imp);
    
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_ref);
    
    %run delay 1
    b = [zeros(handles.delay1,1);1];
    a = [1;zeros(handles.delay1,1)];
    %get impulse response
    imp_D1 = filter(b,a,imp_DNA);
    
    %run allpass filter 
    b = [-handles.A_gain;zeros(handles.A_delay-1,1);1];
    a = [1;zeros(handles.A_delay-1,1);-handles.A_gain];
    %get impulse response
    imp_A = filter(b,a,imp_D1);

    %run delay 2
    b = [zeros(handles.delay2,1);1];
    a = [1;zeros(handles.delay2,1)];
    %get impulse response
    imp_D2 = filter(b,a,imp_A);

    %run delay 3
    b = [zeros(handles.delay3,1);1];
    a = [1;zeros(handles.delay3,1)];
    %get impulse response
    imp_D3 = filter(b,a,imp_D2);
    
    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,Gain_input*imp_D3+handles.gain_add*imp);
     
    %get impulse response
    handles.imp_out_R = Plus2(handles.gain*imp_DNA,handles.gain*imp_D2);
    handles.imp_out_R = Plus2(handles.imp_out_R,handles.gain*imp_SNA);
    
    handles.imp_out = [handles.imp_out_L, handles.imp_out_R];

   handles.imp_out = Plus2(handles.imp_out,fliplr(handles.imp_out)*corr_scale); % If you want to increase channel correlation

    if handles.HRIR_DS == 0
        handles.imp_out = Plus2(handles.imp_out, imp); % Adding in direct sound here!
    else
        [HRIR, ~] = audioread('azi_0,0_ele_0,0.wav'); 
        [~, HRIR_mp] = rceps(HRIR); % Get min phase HRTF just for this example 
        handles.imp_out = Plus2(handles.imp_out, HRIR_mp); % Make direct sound a HRTF
    end

    %% Match Timbre L
    handles.imp_out_L = handles.imp_out(:,1);
    RealImp_L = RealImp(:,1);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_L, I1_L] = max(abs(handles.imp_out_L));
    [m2_L, I2_L] = max(abs(RealImp_L));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_L = zeros(size(handles.imp_out_L)); % Initialise reverb arrays
    hRev2_L = zeros(size(RealImp_L));

    hRev1_L(I1_L+nSkipsamps:end) = handles.imp_out_L((I1_L+nSkipsamps:end)); % Reverb portion only
    hRev2_L(I2_L+nSkipsamps:end) = RealImp_L((I2_L+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_L = fftfilt(b(i,:), hRev1_L, nfft); % Filter IR 1
        hRev2filt_L = fftfilt(b(i,:), hRev2_L, nfft); % Filter IR 2

        dB_h1_L(i) = 20*log10(rms(hRev1filt_L)); % Compute rms average dB value
        dB_h2_L(i) = 20*log10(rms(hRev2filt_L)); 
        dB_diff_L(i) = dB_h2_L(i)-dB_h1_L(i); % Estimate difference in dB       


        hout_L(i,:) = hRev1filt_L*db2mag(dB_diff_L(i)); % Scale IR 1 by difference

        dB_hout_L(i) = 20*log10(rms(hout_L(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_L = sum(hout_L)';
    % Remove offset
    hout_L = hout_L(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_L_Fout(1:I1_L+nSkipsamps) = [handles.imp_out_L(1:I1_L+nSkipsamps-nSkipsamps/2); handles.imp_out_L(I1_L+nSkipsamps-nSkipsamps/2+1:I1_L+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_L_FIn(1:I1_L+nSkipsamps) = [hout_L(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_L(nSkipsamps/2+1:I1_L+nSkipsamps)];   % Fade in Hanning windows
    hout_L(1:I1_L+nSkipsamps) = hout_L_Fout(1:I1_L+nSkipsamps) + hout_L_FIn(1:I1_L+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_L);
    hold on
    plot(dB_h2_L, 'r');
    plot(dB_diff_L, 'k:');
    plot(dB_hout_L, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (L channel)');


    %% Match Timbre R
    handles.imp_out_R = handles.imp_out(:,2);
    RealImp_R = RealImp(:,2);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_R, I1_R] = max(abs(handles.imp_out_R));
    [m2_R, I2_R] = max(abs(RealImp_R));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_R = zeros(size(handles.imp_out_R)); % Initialise reverb arrays
    hRev2_R = zeros(size(RealImp_R));

    hRev1_R(I1_R+nSkipsamps:end) = handles.imp_out_R((I1_R+nSkipsamps:end)); % Reverb portion only
    hRev2_R(I2_R+nSkipsamps:end) = RealImp_R((I2_R+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_R = fftfilt(b(i,:), hRev1_R, nfft); % Filter IR 1
        hRev2filt_R = fftfilt(b(i,:), hRev2_R, nfft); % Filter IR 2

        dB_h1_R(i) = 20*log10(rms(hRev1filt_R)); % Compute rms average dB value
        dB_h2_R(i) = 20*log10(rms(hRev2filt_R)); 
        dB_diff_R(i) = dB_h2_R(i)-dB_h1_R(i); % Estimate difference in dB       


        hout_R(i,:) = hRev1filt_R*db2mag(dB_diff_R(i)); % Scale IR 1 by difference

        dB_hout_R(i) = 20*log10(rms(hout_R(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_R = sum(hout_R)';
    % Remove offset
    hout_R = hout_R(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_R_Fout(1:I1_R+nSkipsamps) = [handles.imp_out_R(1:I1_R+nSkipsamps-nSkipsamps/2); handles.imp_out_R(I1_R+nSkipsamps-nSkipsamps/2+1:I1_R+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_R_FIn(1:I1_R+nSkipsamps) = [hout_R(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_R(nSkipsamps/2+1:I1_R+nSkipsamps)];   % Fade in Hanning windows
    hout_R(1:I1_R+nSkipsamps) = hout_R_Fout(1:I1_R+nSkipsamps) + hout_R_FIn(1:I1_R+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_R);
    hold on
    plot(dB_h2_R, 'r');
    plot(dB_diff_R, 'k:');
    plot(dB_hout_R, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (R channel)');

    handles.imp_out = [hout_L, hout_R];   % Combine left and right channel
    
    
    C = round(0.0025 * handles.Fs); 
    [m, I] = max(abs(handles.imp_out));
    if (min(I) - C <= 0)
        handles.imp_out = [zeros(C-min(I)+1, 2); handles.imp_out];  
    end
    [m, I] = max(abs(handles.imp_out));
    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_orig = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_out(I+C+1:end,:) = (handles.imp_out(I+C+1:end,:)*DRR_orig)/handles.DRR; % Scale reverb for desired DRR;

    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_final = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR    

    handles.imp_final_L = handles.imp_out(:, 1);
    handles.imp_final_R = handles.imp_out(:, 2);

    %% Compute IACC
    maxlags = round(0.001 * handles.Fs); % Maximum lag for correlation (cross head delay)
    [IACC] = max(abs(xcorr(handles.imp_final_L, handles.imp_final_R, maxlags, 'normalized' )))
    
    %normalise the output
    handles.imp_out = handles.imp_out ./ max(abs(handles.imp_out));
    
    N = length(handles.audio)+length(handles.imp_out)-1;	%confirm the length of FFT
    L = pow2(nextpow2(N));	%confirm the length of 2FFT
    X = fft(handles.audio,L);
    H = fft(handles.imp_out,L);
    Y = X .* H;
    handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
    
    disp(num2str(toc));
    
    plotFigure(handles.imp_out,handles.Fs) 

    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(handles.imp_out)-1)/handles.Fs,length(handles.imp_out)),handles.imp_out);
    title('Medium room impulse response');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('Medium room Gardner filter');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < handles.delay4)
        power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
        power_of_2 = 10;
    end
    
    %return a frequency vector to give the x axis in Hz
    H = fft(handles.imp_out,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('Medium room frequency response');
    xlabel('Frequency (Hz)');
    ylabel('Amplitude');
    
    %update handles  
    guidata(hObject, handles);
    
    
% --- Executes on button press in Gardner_small_button.
function Gardner_small_button_Callback(hObject, eventdata, handles)
% hObject    handle to Gardner_small_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic;
    Delvar = 0.9;        % Randomness in difference of L and R delays
    corr_scale = 0;    % Amount of channel correlation. 1 is identical left and right signals
    handles.HRIR_DS = 1;         % Additional flag to add a HRIR as direct sound. 
    [RealImp, handles.Fs] = audioread('0.266s_BinauralRealImpulseResponse.wav');
    RealImp = RealImp ./ max(abs(RealImp));

    %---------------Left channel--------------%
    %set filter parameters
    handles.LP_gain = 0.6;
    handles.DNAO_gain = 0.3;
    handles.DNAI1_gain = 0.4;
    handles.DNAI2_gain = 0.6;
    handles.SNAO_gain = 0.1;
    handles.SNAI_gain = 0.4;
    handles.gain = 0.5;
    handles.L_gain = 1/4200;

    handles.temp = 8;
    handles.delay = round(24 * handles.temp);
    handles.DNAO_delay = round(35 * handles.temp);
    handles.DNAI1_delay = round(22 * handles.temp);
    handles.DNAI2_delay = round(8.3 * handles.temp);
    handles.SNAO_delay = round(66 * handles.temp);
    handles.SNAI_delay = round(30 * handles.temp);  
    
    delay_G = handles.delay+handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay+handles.SNAO_delay+handles.SNAI_delay;
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/handles.RT60_input);

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function   
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv([zeros(handles.delay,1);1],brefDN);
    bref1 = conv(bref1,brefSN);
    bref1 = conv(bref1,[1-handles.L_gain;zeros(round(handles.L_gain*handles.Fs),1)]);
    aref1 = conv(arefDN,arefSN);
    aref1 = conv(aref1,[1;-handles.L_gain;zeros(round(handles.L_gain*handles.Fs)-1,1)]);   
    
    bref = aref1;
    aref = Plus2(aref1,-Gain_input*bref1);
    
    %Compute lowpass transfer function
    b = [1-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs),1)];
    a = [1;-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs)-1,1)];
    %get impulse response
    imp_LP = filter(b,a,imp);

    %get impulse response
    imp_ref = filter(bref,aref,imp_LP);
    
    %run delay 
    b = [zeros(handles.delay,1);1];
    a = [1;zeros(handles.delay,1)];
    %get impulse response
    imp_D = filter(b,a,imp_ref);
    
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_D);

    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,imp_DNA);
     
    %get impulse response
    handles.imp_out_L = Plus2(handles.gain*imp_DNA,handles.gain*imp_SNA);
    
    %---------------Right channel--------------%
    %set filter parameters
    handles.LP_gain = 0.6;
    handles.DNAO_gain = 0.3;
    handles.DNAI1_gain = 0.4;
    handles.DNAI2_gain = 0.6;
    handles.SNAO_gain = 0.1;
    handles.SNAI_gain = 0.4;
    handles.gain = 0.5;
    handles.L_gain = 1/4200;

    handles.temp = 8;
    handles.delay = round(24 * handles.temp  * (1 + Delvar));
    handles.DNAO_delay = round(35 * handles.temp  * (1 + Delvar));
    handles.DNAI1_delay = round(22 * handles.temp  * (1 + Delvar));
    handles.DNAI2_delay = round(8.3 * handles.temp  * (1 + Delvar));
    handles.SNAO_delay = round(66 * handles.temp  * (1 + Delvar));
    handles.SNAI_delay = round(30 * handles.temp  * (1 + Delvar));  
    
    delay_G = (handles.delay+handles.DNAO_delay+handles.DNAI1_delay+handles.DNAI2_delay+handles.SNAO_delay+handles.SNAI_delay) * (1 + Delvar);
    delay_G = delay_G/handles.Fs;
    Gain_input = 0.001^(delay_G/handles.RT60_input);

    %create impulse vector (set its length to RT60)
    imp = [1;zeros(round(handles.RT60_input*handles.Fs),1)];

    %Compute D_Nested allpass transfer function   
    brefDN1 = conv([zeros(handles.DNAO_delay,1);1],[-handles.DNAI1_gain;zeros(handles.DNAI1_delay-1,1);1]);
    brefDN1 = conv(brefDN1,[-handles.DNAI2_gain;zeros(handles.DNAI2_delay-1,1);1]);
    arefDN1 = conv([1;zeros(handles.DNAI1_delay-1,1);-handles.DNAI1_gain],[1;zeros(handles.DNAI2_delay-1,1);-handles.DNAI2_gain]);
    
    brefDN = Plus2(-handles.DNAO_gain*arefDN1,brefDN1);
    arefDN = Plus2(arefDN1,-handles.DNAO_gain*brefDN1);
    
    %Compute S_Nested allpass transfer function
    brefSN1 = conv([zeros(handles.SNAO_delay,1);1],[-handles.SNAI_gain;zeros(handles.SNAI_delay-1,1);1]);
    arefSN1 = [1;zeros(handles.SNAI_delay-1,1);-handles.SNAI_gain];
    
    brefSN = Plus2(-handles.SNAO_gain*arefSN1,brefSN1);
    arefSN = Plus2(arefSN1,-handles.SNAO_gain*brefSN1);
    
    %Compute reference transfer function
    bref1 = conv([zeros(handles.delay,1);1],brefDN);
    bref1 = conv(bref1,brefSN);
    bref1 = conv(bref1,[1-handles.L_gain;zeros(round(handles.L_gain*handles.Fs),1)]);
    aref1 = conv(arefDN,arefSN);
    aref1 = conv(aref1,[1;-handles.L_gain;zeros(round(handles.L_gain*handles.Fs)-1,1)]);   
    
    bref = aref1;
    aref = Plus2(aref1,-Gain_input*bref1);

    %Compute lowpass transfer function
    b = [1-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs),1)];
    a = [1;-handles.LP_gain;zeros(round(handles.LP_gain*handles.Fs)-1,1)];
    %get impulse response
    imp_LP = filter(b,a,imp);

    %get impulse response
    imp_ref = filter(bref,aref,imp_LP);
    
    %run delay 
    b = [zeros(handles.delay,1);1];
    a = [1;zeros(handles.delay,1)];
    %get impulse response
    imp_D = filter(b,a,imp_ref);
    
    %run D_Nested allpass 
    b = brefDN;
    a = arefDN;
    %get impulse response
    imp_DNA = filter(b,a,imp_D);

    %run S_Nested allpass 
    b = brefSN;
    a = arefSN;
    %get impulse response
    imp_SNA = filter(b,a,imp_DNA);
     
    %get impulse response
    handles.imp_out_R = Plus2(handles.gain*imp_DNA,handles.gain*imp_SNA);
    
    handles.imp_out = [handles.imp_out_L, handles.imp_out_R];   % Combine left and right channel
   
    handles.imp_out = Plus2(handles.imp_out,fliplr(handles.imp_out)*corr_scale); % If you want to increase channel correlation
    
    if handles.HRIR_DS == 0
        handles.imp_out = Plus2(handles.imp_out, imp); % Adding in direct sound here!
    else
        [HRIR, ~] = audioread('azi_0,0_ele_0,0.wav'); 
        [~, HRIR_mp] = rceps(HRIR); % Get min phase HRTF just for this example 
        handles.imp_out = Plus2(handles.imp_out, HRIR_mp); % Make direct sound a HRTF
    end
    
    %% Match Timbre L
    handles.imp_out_L = handles.imp_out(:,1);
    RealImp_L = RealImp(:,1);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_L, I1_L] = max(abs(handles.imp_out_L));
    [m2_L, I2_L] = max(abs(RealImp_L));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_L = zeros(size(handles.imp_out_L)); % Initialise reverb arrays
    hRev2_L = zeros(size(RealImp_L));

    hRev1_L(I1_L+nSkipsamps:end) = handles.imp_out_L((I1_L+nSkipsamps:end)); % Reverb portion only
    hRev2_L(I2_L+nSkipsamps:end) = RealImp_L((I2_L+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_L = fftfilt(b(i,:), hRev1_L, nfft); % Filter IR 1
        hRev2filt_L = fftfilt(b(i,:), hRev2_L, nfft); % Filter IR 2

        dB_h1_L(i) = 20*log10(rms(hRev1filt_L)); % Compute rms average dB value
        dB_h2_L(i) = 20*log10(rms(hRev2filt_L)); 
        dB_diff_L(i) = dB_h2_L(i)-dB_h1_L(i); % Estimate difference in dB       


        hout_L(i,:) = hRev1filt_L*db2mag(dB_diff_L(i)); % Scale IR 1 by difference

        dB_hout_L(i) = 20*log10(rms(hout_L(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_L = sum(hout_L)';
    % Remove offset
    hout_L = hout_L(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_L_Fout(1:I1_L+nSkipsamps) = [handles.imp_out_L(1:I1_L+nSkipsamps-nSkipsamps/2); handles.imp_out_L(I1_L+nSkipsamps-nSkipsamps/2+1:I1_L+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_L_FIn(1:I1_L+nSkipsamps) = [hout_L(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_L(nSkipsamps/2+1:I1_L+nSkipsamps)];   % Fade in Hanning windows
    hout_L(1:I1_L+nSkipsamps) = hout_L_Fout(1:I1_L+nSkipsamps) + hout_L_FIn(1:I1_L+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_L);
    hold on
    plot(dB_h2_L, 'r');
    plot(dB_diff_L, 'k:');
    plot(dB_hout_L, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (L channel)');


    %% Match Timbre R
    handles.imp_out_R = handles.imp_out(:,2);
    RealImp_R = RealImp(:,2);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_R, I1_R] = max(abs(handles.imp_out_R));
    [m2_R, I2_R] = max(abs(RealImp_R));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_R = zeros(size(handles.imp_out_R)); % Initialise reverb arrays
    hRev2_R = zeros(size(RealImp_R));

    hRev1_R(I1_R+nSkipsamps:end) = handles.imp_out_R((I1_R+nSkipsamps:end)); % Reverb portion only
    hRev2_R(I2_R+nSkipsamps:end) = RealImp_R((I2_R+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_R = fftfilt(b(i,:), hRev1_R, nfft); % Filter IR 1
        hRev2filt_R = fftfilt(b(i,:), hRev2_R, nfft); % Filter IR 2

        dB_h1_R(i) = 20*log10(rms(hRev1filt_R)); % Compute rms average dB value
        dB_h2_R(i) = 20*log10(rms(hRev2filt_R)); 
        dB_diff_R(i) = dB_h2_R(i)-dB_h1_R(i); % Estimate difference in dB       


        hout_R(i,:) = hRev1filt_R*db2mag(dB_diff_R(i)); % Scale IR 1 by difference

        dB_hout_R(i) = 20*log10(rms(hout_R(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_R = sum(hout_R)';
    % Remove offset
    hout_R = hout_R(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_R_Fout(1:I1_R+nSkipsamps) = [handles.imp_out_R(1:I1_R+nSkipsamps-nSkipsamps/2); handles.imp_out_R(I1_R+nSkipsamps-nSkipsamps/2+1:I1_R+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_R_FIn(1:I1_R+nSkipsamps) = [hout_R(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_R(nSkipsamps/2+1:I1_R+nSkipsamps)];   % Fade in Hanning windows
    hout_R(1:I1_R+nSkipsamps) = hout_R_Fout(1:I1_R+nSkipsamps) + hout_R_FIn(1:I1_R+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_R);
    hold on
    plot(dB_h2_R, 'r');
    plot(dB_diff_R, 'k:');
    plot(dB_hout_R, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (R channel)');

    handles.imp_out = [hout_L, hout_R];   % Combine left and right channel    
    
    
    
    C = round(0.0025 * handles.Fs); 
    [m, I] = max(abs(handles.imp_out));
    if (min(I) - C <= 0)
        handles.imp_out = [zeros(C-min(I)+1, 2); handles.imp_out];  
    end
    [m, I] = max(abs(handles.imp_out));
    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_orig = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_out(I+C+1:end,:) = (handles.imp_out(I+C+1:end,:)*DRR_orig)/handles.DRR; % Scale reverb for desired DRR;

    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_final = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR
    
    handles.imp_final_L = handles.imp_out(:, 1);
    handles.imp_final_R = handles.imp_out(:, 2);
    
    %% Compute IACC
    maxlags = round(0.001 * handles.Fs); % Maximum lag for correlation (cross head delay)
    [IACC] = max(abs(xcorr(handles.imp_final_L, handles.imp_final_R, maxlags, 'normalized' )))
    
    %normalise the output
    handles.imp_out = handles.imp_out ./ max(abs(handles.imp_out));    
    
    N = length(handles.audio)+length(handles.imp_out)-1;	%confirm the length of FFT
    L = pow2(nextpow2(N));	%confirm the length of 2FFT
    X = fft(handles.audio,L);
    H = fft(handles.imp_out,L);
    Y = X .* H;
    handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));

    disp(num2str(toc));
    
    plotFigure(handles.imp_out,handles.Fs) 

    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(handles.imp_out)-1)/handles.Fs,length(handles.imp_out)),handles.imp_out);
    title('Small room impulse response');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('Small room Gardner filter');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < handles.SNAO_delay)
        power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
        power_of_2 = 10;
    end
    
    %return a frequency vector to give the x axis in Hz
    H = fft(handles.imp_out,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('Small room frequency response');
    xlabel('Frequency (Hz)');
    ylabel('Amplitude');
    
    %update handles  
    guidata(hObject, handles);
   



function DRR_Callback(hObject, eventdata, handles)
% hObject    handle to DRR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DRR as text
%        str2double(get(hObject,'String')) returns contents of DRR as a double
handles.DRR = str2double(get(hObject,'string'));
if isnan(handles.DRR)
errordlg('You must enter a numeric value','Bad Input','modal')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function DRR_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DRR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
