function varargout = Realreverberation(varargin)
%REALREVERBERATION MATLAB code file for Realreverberation.fig
%      REALREVERBERATION, by itself, creates a new REALREVERBERATION or raises the existing
%      singleton*.
%
%      H = REALREVERBERATION returns the handle to a new REALREVERBERATION or the handle to
%      the existing singleton*.
%
%      REALREVERBERATION('Property','Value',...) creates a new REALREVERBERATION using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to Realreverberation_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      REALREVERBERATION('CALLBACK') and REALREVERBERATION('CALLBACK',hObject,...) call the
%      local function named CALLBACK in REALREVERBERATION.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Realreverberation

% Last Modified by GUIDE v2.5 25-Sep-2019 19:20:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Realreverberation_OpeningFcn, ...
                   'gui_OutputFcn',  @Realreverberation_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Realreverberation is made visible.
function Realreverberation_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for Realreverberation
    handles.output = hObject;
    handles.file = 'Enter full path and file name';
    handles.Impfile = 'Enter full path and file name';
    
% Update handles structure
    guidata(hObject, handles);

% UIWAIT makes Realreverberation wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Realreverberation_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
    varargout{1} = handles.output;



function File_path_Callback(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of File_path as text
%        str2double(get(hObject,'String')) returns contents of File_path as a double
    handles.file = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function File_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Open_audio_button.
function Open_audio_button_Callback(hObject, eventdata, handles)
% hObject    handle to Open_audio_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    if (strcmp(handles.file,'Enter full path and file name')||strcmp(handles.file,'You must enter a filename first!'))
        set(handles.file_path, 'string', 'You must enter a filename first!');
    else
        [handles.audio, handles.Fs] = audioread(handles.file); 
        
        %display unprocessed audio wave
        axes(handles.Unprocessed_audio);      %set which axes to plot on
        plot(linspace(0,(length(handles.audio)-1)/handles.Fs,length(handles.audio)),handles.audio);
        title('sound');     
    end
       
    guidata(hObject, handles);

% --- Executes on button press in Play_unprocessed_button.
function Play_unprocessed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_unprocessed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.audio,handles.Fs);

% --- Executes on button press in Convolution_button.
function Convolution_button_Callback(hObject, eventdata, handles)
% hObject    handle to Convolution_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    %ESB convolution
    Final_Fs = handles.Fs
    N = length(handles.audio)+length(handles.Imp)-1;	%confirm the length of FFT
    L = pow2(nextpow2(N));	%confirm the length of 2FFT
    X = fft(handles.audio,L);
    H = fft(handles.Imp,L);
    Y = X .* H;
    handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
       
    %display processed audio
    axes(handles.Processed_audio);     %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    v = axis; %get current axis scaling
    v(1) = 0;
    v(2) = length(handles.audio)/handles.Fs+2; %set scale of x axis
    axis(v);
    title('Processed audio');
    xlabel('Time (s)');
    ylabel('Amplitude');
      
    %plot frequency response
    gain = abs(H);
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : L-1;
    F = n*handles.Fs/L;    %frequency sequence
    plot(F,gain);
    title('Frequency response');
    xlabel('Frequency (Hz)');
    ylabel('Amplitude');
    
    guidata(hObject, handles);

% --- Executes on button press in Play_processed_button.
function Play_processed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_processed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.processed_audio, handles.Fs);

function Save_path_Callback(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Save_path as text
%        str2double(get(hObject,'String')) returns contents of Save_path as a double
    handles.save = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Save_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Save_button.
function Save_button_Callback(hObject, eventdata, handles)
% hObject    handle to Save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    audiowrite(handles.save,handles.processed_audio,handles.Fs);
    guidata(hObject, handles);



function Imp_path_Callback(hObject, eventdata, handles)
% hObject    handle to Imp_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Imp_path as text
%        str2double(get(hObject,'String')) returns contents of Imp_path as a double
    handles.Impfile = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Imp_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Imp_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Open_Imp_button.
function Open_Imp_button_Callback(hObject, eventdata, handles)
% hObject    handle to Open_Imp_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    if (strcmp(handles.Impfile,'Enter full path and file name')||strcmp(handles.Impfile,'You must enter a filename first!'))
        set(handles.Imp_path, 'string', 'You must enter a filename first!');
    else
        [handles.Imp, handles.Fs] = audioread(handles.Impfile); 
        
        C = round(0.0025 * handles.Fs);
        [m, I] = max(abs(handles.Imp));
        if (min(I) - C <= 0)
            Direct = handles.Imp(1: I+C, :);
        else
            Direct = handles.Imp(I-C: I+C, :);
        end
        Reverb = handles.Imp(I+C+1: end, :);

        DRR = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

        [Fir_Ref, pointR] = max(abs(Reverb));
        pointR = pointR + I + C;

        ITDG = (mean(pointR) - mean(I))/handles.Fs

        handles.imp_out_L = handles.Imp(:, 1);
        handles.imp_out_R = handles.Imp(:, 2);
        
        % Compute IACC
        maxlags = round(0.001*handles.Fs); % Maximum lag for correlation (cross head delay)
        [IACC] = max(abs(xcorr(handles.imp_out_L, handles.imp_out_R, maxlags, 'normalized' )))
        
        %normalise the RIR
        handles.Imp = handles.Imp ./ max(abs(handles.Imp));
        
        plotFigure(handles.Imp,handles.Fs) 
        
        %display impulse response
        axes(handles.Impulse_response);      %set which axes to plot on
        plot(linspace(0,(length(handles.Imp)-1)/handles.Fs,length(handles.Imp)),handles.Imp);
        title('Impulse response');
        xlabel('Time (s)');
        ylabel('Amplitude');
    end
       
    guidata(hObject, handles);

% --- Executes on button press in Play_Imp_button.
function Play_Imp_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_Imp_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.Imp, handles.Fs);
