function varargout = Schroeder(varargin)        %RT60=3.4,A1_RT60=0.09683,A2_RT60=0.03292,C1_D=0.0297,C2_D=0.0371,C3_D=0.0411,C4_D=0.0437,A1_D=0.005,A2_D=0.0017
% SCHROEDER MATLAB code for Schroeder.fig
%      SCHROEDER, by itself, creates a new SCHROEDER or raises the existing
%      singleton*.
%
%      H = SCHROEDER returns the handle to a new SCHROEDER or the handle to
%      the existing singleton*.
%
%      SCHROEDER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SCHROEDER.M with the given input arguments.
%
%      SCHROEDER('Property','Value',...) creates a new SCHROEDER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Schroeder_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Schroeder_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Schroeder

% Last Modified by GUIDE v2.5 06-Aug-2021 21:32:02

% Begin initialization code - DO NOT EDIT
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                       'gui_Singleton',  gui_Singleton, ...
                       'gui_OpeningFcn', @Schroeder_OpeningFcn, ...
                       'gui_OutputFcn',  @Schroeder_OutputFcn, ...
                       'gui_LayoutFcn',  [] , ...
                       'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
% End initialization code - DO NOT EDIT

%%
% Plus2.M
% This function adds two vectors of different lengths.
% (Matlab standard "+" operator doesn't work with
%  vectors of different lenghts).
% ____________________________________________________

function [vec3] = Plus2(vec1,vec2)
    len1=length(vec1);
    len2=length(vec2);
    
    if len1 < len2
       vec3(1:len1,:)=vec1(1:len1,:)+vec2(1:len1,:);
       vec3(len1+1:len2,:)=vec2(len1+1:len2,:);
    elseif len1 > len2
       vec3(1:len2,:)=vec1(1:len2,:)+vec2(1:len2,:);
       vec3(len2+1:len1,:)=vec1(len2+1:len1,:);
    else
       vec3 = vec1+vec2;
    end


% --- Executes just before Schroeder is made visible.
function Schroeder_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Schroeder (see VARARGIN)

% Choose default command line output for Schroeder
    handles.output = hObject;
    handles.file = 'Enter full path and file name';
    
% Update handles structure
    guidata(hObject, handles);

% UIWAIT makes Schroeder wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Schroeder_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
    varargout{1} = handles.output;


% --- Executes on button press in Open_button.
function Open_button_Callback(hObject, eventdata, handles)
% hObject    handle to Open_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    if (strcmp(handles.file,'Enter full path and file name')||strcmp(handles.file,'You must enter a filename first!'))
        set(handles.file_path, 'string', 'You must enter a filename first!');
    else
        [handles.audio, handles.Fs] = audioread(handles.file); 
        handles.audio = handles.audio./max(abs(handles.audio));
        axes(handles.Unprocessed_audio);      %set which axes to plot on
        plot(linspace(0,(length(handles.audio)-1)/handles.Fs,length(handles.audio)),handles.audio);
        title('sound');
        xlabel('Time (s)');
        ylabel('Amplitude');
    end
    guidata(hObject, handles);

% --- Executes on button press in Play_unprocessed_button.
function Play_unprocessed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_unprocessed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.audio,handles.Fs);

function File_path_Callback(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of File_path as text
%        str2double(get(hObject,'String')) returns contents of File_path as a double
    handles.file = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function File_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to File_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end


% --- Executes on button press in Schroeder_filter_button.
function Schroeder_filter_button_Callback(hObject, eventdata, handles)
% hObject    handle to Schroeder_filter_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic;
    if (handles.RT60 == 0.266)
        Delvar = 0.3;        % Randomness in difference of L and R delays
        corr_scale = 0;    % Amount of channel correlation. 1 is identical left and right signals
        [RealImp, handles.Fs] = audioread('0.266s_BinauralRealImpulseResponse.wav');
        RealImp = RealImp ./ max(abs(RealImp));
    elseif (handles.RT60 == 0.95) 
        Delvar = 0.1;        % Randomness in difference of L and R delays
        corr_scale = 0.0069;    % Amount of channel correlation. 1 is identical left and right signals
        [RealImp, handles.Fs] = audioread('0.95s_BinauralRealImpulseResponse.wav');
        RealImp = RealImp ./ max(abs(RealImp));
    elseif (handles.RT60 == 2.34)  
        Delvar = 0.4;        % Randomness in difference of L and R delays
        corr_scale = 0;    % Amount of channel correlation. 1 is identical left and right signals
        [RealImp, handles.Fs] = audioread('2.34s_BinauralRealImpulseResponse.wav');
        RealImp = RealImp ./ max(abs(RealImp));
    end
    
    handles.HRIR_DS = 1;         % Additional flag to add a HRIR as direct sound. 
 
    %---------------Left channel--------------%
    handles.C1_Delay = 0.0297;
    handles.C2_Delay = 0.0371;
    handles.C3_Delay = 0.0411;
    handles.C4_Delay = 0.0437;
    handles.A1_Delay = 0.005;
    handles.A2_Delay = 0.0017;
    
    handles.A1_RT60 = 0.09683;
    handles.A2_RT60 = 0.03292;

    %calculate gains ('g') based on delay and RT60
    C1_gain=0.001^(handles.C1_Delay/handles.RT60);
    C2_gain=0.001^(handles.C2_Delay/handles.RT60);
    C3_gain=0.001^(handles.C3_Delay/handles.RT60);
    C4_gain=0.001^(handles.C4_Delay/handles.RT60);
    A1_gain=0.001^(handles.A1_Delay/handles.A1_RT60);
    A2_gain=0.001^(handles.A2_Delay/handles.A2_RT60);
    
    %convert combdelay value to samples
    C1_Delay = round(handles.C1_Delay * handles.Fs);
    C2_Delay = round(handles.C2_Delay * handles.Fs);
    C3_Delay = round(handles.C3_Delay * handles.Fs);
    C4_Delay = round(handles.C4_Delay * handles.Fs);
    A1_Delay = round(handles.A1_Delay * handles.Fs);
    A2_Delay = round(handles.A2_Delay * handles.Fs);
    
    %create impulse vector (set its length to RT60)
    imp=[1;zeros(round(handles.RT60 * handles.Fs),1)];
    
    %run 4 comb filters in parallel
    %using y[n] = x[n+T] + g.y[n + T]
    b = [zeros(C1_Delay,1);1];
    a = [1; zeros(C1_Delay-1,1); -C1_gain];
    %get impulse response
    imp_C1 = filter(b,a,imp);
    
    b = [zeros(C2_Delay,1);1];
    a = [1; zeros(C2_Delay-1,1); -C2_gain];
    %get impulse response
    imp_C2 = filter(b,a,imp);
    
    b = [zeros(C3_Delay,1);1];
    a = [1; zeros(C3_Delay-1,1); -C3_gain];
    %get impulse response
    imp_C3 = filter(b,a,imp);
    
    b = [zeros(C4_Delay,1);1];
    a = [1; zeros(C4_Delay-1,1); -C4_gain];
    %get impulse response
    imp_C4 = filter(b,a,imp);
    
    %sum outputs
    imp_comb = (imp_C1 * 0.25) + (imp_C2 * 0.25) + (imp_C3 * 0.25) + (imp_C4 * 0.25);
   
    %set up the all pass filter as the following to use with 'filter'
    %y[n] = -g.x[n] + x[n+T] + g.y[n + T]
    b = [-A1_gain; zeros(A1_Delay-1,1);1];
    a = [1;zeros(A1_Delay-1,1); -A1_gain];
    %get impulse response
    imp_A1 = filter(b,a,imp_comb);
    
    b = [-A2_gain; zeros(A2_Delay-1,1);1];
    a = [1;zeros(A2_Delay-1,1); -A2_gain];
    %get impulse response
    handles.imp_out_L = filter(b,a,imp_A1);

    %---------------Right channel--------------%
    handles.C1_Delay = 0.0297;
    handles.C2_Delay = 0.0371;
    handles.C3_Delay = 0.0411;
    handles.C4_Delay = 0.0437;
    handles.A1_Delay = 0.005;
    handles.A2_Delay = 0.0017;
    
    handles.A1_RT60 = 0.09683;
    handles.A2_RT60 = 0.03292;

    %calculate gains ('g') based on delay and RT60
    C1_gain=0.001^(handles.C1_Delay/handles.RT60);
    C2_gain=0.001^(handles.C2_Delay/handles.RT60);
    C3_gain=0.001^(handles.C3_Delay/handles.RT60);
    C4_gain=0.001^(handles.C4_Delay/handles.RT60);
    A1_gain=0.001^(handles.A1_Delay/handles.A1_RT60);
    A2_gain=0.001^(handles.A2_Delay/handles.A2_RT60);
    
    
    %convert combdelay value to samples
    C1_Delay = round(handles.C1_Delay * handles.Fs + 297 * Delvar);
    C2_Delay = round(handles.C2_Delay * handles.Fs + 371 * Delvar);
    C3_Delay = round(handles.C3_Delay * handles.Fs + 411 * Delvar);
    C4_Delay = round(handles.C4_Delay * handles.Fs + 437 * Delvar);
    A1_Delay = round(handles.A1_Delay * handles.Fs + 50 * Delvar);
    A2_Delay = round(handles.A2_Delay * handles.Fs + 17 * Delvar);
    
    %create impulse vector (set its length to RT60)
    imp=[1;zeros(round(handles.RT60 * handles.Fs),1)];
    
    %run 4 comb filters in parallel
    %using y[n] = x[n+T] + g.y[n + T]
    b = [zeros(C1_Delay,1);1];
    a = [1; zeros(C1_Delay-1,1); -C1_gain];
    %get impulse response
    imp_C1 = filter(b,a,imp);
    
    b = [zeros(C2_Delay,1);1];
    a = [1; zeros(C2_Delay-1,1); -C2_gain];
    %get impulse response
    imp_C2 = filter(b,a,imp);
    
    b = [zeros(C3_Delay,1);1];
    a = [1; zeros(C3_Delay-1,1); -C3_gain];
    %get impulse response
    imp_C3 = filter(b,a,imp);
    
    b = [zeros(C4_Delay,1);1];
    a = [1; zeros(C4_Delay-1,1); -C4_gain];
    %get impulse response
    imp_C4 = filter(b,a,imp);
    
    %sum outputs
    imp_comb = (imp_C1 * 0.25) + (imp_C2 * 0.25) + (imp_C3 * 0.25) + (imp_C4 * 0.25);
    
    %set up the all pass filter as the following to use with 'filter'
    %y[n] = -g.x[n] + x[n+T] + g.y[n + T]
    b = [-A1_gain; zeros(A1_Delay-1,1);1];
    a = [1;zeros(A1_Delay-1,1); -A1_gain];
    %get impulse response
    imp_A1 = filter(b,a,imp_comb);
    
    b = [-A2_gain; zeros(A2_Delay-1,1);1];
    a = [1;zeros(A2_Delay-1,1); -A2_gain];
    %get impulse response
    handles.imp_out_R = filter(b,a,imp_A1);

    handles.imp_out = [handles.imp_out_L, handles.imp_out_R];
   
    handles.imp_out = Plus2(handles.imp_out,fliplr(handles.imp_out)*corr_scale); % If you want to increase channel correlation

    if handles.HRIR_DS == 0
        handles.imp_out = Plus2(handles.imp_out, imp); % Adding in direct sound here!
    else
        [HRIR, ~] = audioread('azi_0,0_ele_0,0.wav'); 
        [~, HRIR_mp] = rceps(HRIR); % Get min phase HRTF just for this example 
        handles.imp_out = Plus2(handles.imp_out, HRIR_mp); % Make direct sound a HRTF
    end

    %% Match Timbre L
    handles.imp_out_L = handles.imp_out(:,1);
    RealImp_L = RealImp(:,1);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_L, I1_L] = max(abs(handles.imp_out_L));
    [m2_L, I2_L] = max(abs(RealImp_L));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_L = zeros(size(handles.imp_out_L)); % Initialise reverb arrays
    hRev2_L = zeros(size(RealImp_L));

    hRev1_L(I1_L+nSkipsamps:end) = handles.imp_out_L((I1_L+nSkipsamps:end)); % Reverb portion only
    hRev2_L(I2_L+nSkipsamps:end) = RealImp_L((I2_L+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_L = fftfilt(b(i,:), hRev1_L, nfft); % Filter IR 1
        hRev2filt_L = fftfilt(b(i,:), hRev2_L, nfft); % Filter IR 2

        dB_h1_L(i) = 20*log10(rms(hRev1filt_L)); % Compute rms average dB value
        dB_h2_L(i) = 20*log10(rms(hRev2filt_L)); 
        dB_diff_L(i) = dB_h2_L(i)-dB_h1_L(i); % Estimate difference in dB       


        hout_L(i,:) = hRev1filt_L*db2mag(dB_diff_L(i)); % Scale IR 1 by difference

        dB_hout_L(i) = 20*log10(rms(hout_L(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_L = sum(hout_L)';
    % Remove offset
    hout_L = hout_L(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_L_Fout(1:I1_L+nSkipsamps) = [handles.imp_out_L(1:I1_L+nSkipsamps-nSkipsamps/2); handles.imp_out_L(I1_L+nSkipsamps-nSkipsamps/2+1:I1_L+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_L_FIn(1:I1_L+nSkipsamps) = [hout_L(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_L(nSkipsamps/2+1:I1_L+nSkipsamps)];   % Fade in Hanning windows
    hout_L(1:I1_L+nSkipsamps) = hout_L_Fout(1:I1_L+nSkipsamps) + hout_L_FIn(1:I1_L+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_L);
    hold on
    plot(dB_h2_L, 'r');
    plot(dB_diff_L, 'k:');
    plot(dB_hout_L, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (L channel)');


    %% Match Timbre R
    handles.imp_out_R = handles.imp_out(:,2);
    RealImp_R = RealImp(:,2);
    % Skip past direct sound, if we want to apply timbre match on reverb only.
    [m1_R, I1_R] = max(abs(handles.imp_out_R));
    [m2_R, I2_R] = max(abs(RealImp_R));

    nSkipsamps = round(0.002*handles.Fs); %2ms of samples 

    hRev1_R = zeros(size(handles.imp_out_R)); % Initialise reverb arrays
    hRev2_R = zeros(size(RealImp_R));

    hRev1_R(I1_R+nSkipsamps:end) = handles.imp_out_R((I1_R+nSkipsamps:end)); % Reverb portion only
    hRev2_R(I2_R+nSkipsamps:end) = RealImp_R((I2_R+nSkipsamps:end));



    %% Create ERB based linear phase filterbank

    nfft = 4096;    % 2^12

    [b CrossoverPoints] = ERBFilterBank(handles.Fs, nfft, 0);


    %% For each ERB band compare and match rms value
    for i = 1:size(b,1)

        hRev1filt_R = fftfilt(b(i,:), hRev1_R, nfft); % Filter IR 1
        hRev2filt_R = fftfilt(b(i,:), hRev2_R, nfft); % Filter IR 2

        dB_h1_R(i) = 20*log10(rms(hRev1filt_R)); % Compute rms average dB value
        dB_h2_R(i) = 20*log10(rms(hRev2filt_R)); 
        dB_diff_R(i) = dB_h2_R(i)-dB_h1_R(i); % Estimate difference in dB       


        hout_R(i,:) = hRev1filt_R*db2mag(dB_diff_R(i)); % Scale IR 1 by difference

        dB_hout_R(i) = 20*log10(rms(hout_R(i,:))); % Compute rms average dB value for output reverb


    end


    %% Sum bands and add direct sound back in
    hout_R = sum(hout_R)';
    % Remove offset
    hout_R = hout_R(nfft/2+1:end);

    Hann_W = hann(nSkipsamps);  % nSkipsamps-point Hanning Window
    hout_R_Fout(1:I1_R+nSkipsamps) = [handles.imp_out_R(1:I1_R+nSkipsamps-nSkipsamps/2); handles.imp_out_R(I1_R+nSkipsamps-nSkipsamps/2+1:I1_R+nSkipsamps).* Hann_W(nSkipsamps/2+1:end)]; % Fade out using Hanning windows
    hout_R_FIn(1:I1_R+nSkipsamps) = [hout_R(1:nSkipsamps/2) .* Hann_W(1:nSkipsamps/2); hout_R(nSkipsamps/2+1:I1_R+nSkipsamps)];   % Fade in Hanning windows
    hout_R(1:I1_R+nSkipsamps) = hout_R_Fout(1:I1_R+nSkipsamps) + hout_R_FIn(1:I1_R+nSkipsamps);    % Add fade out and fade in

    % hout(1:I1+nSkipsamps) = hIn1(1:I1+nSkipsamps); % I've done this crudely here - Really should be a crossfade using Hanning windows


    %% Plot the results
    % 'IR1 Scaled' should now give the same average spectrum as IR2.

    figure()
    plot(dB_h1_R);
    hold on
    plot(dB_h2_R, 'r');
    plot(dB_diff_R, 'k:');
    plot(dB_hout_R, 'go');
    legend('IR 1', 'IR 2', 'Diff', 'IR1 scaled');
    xlabel('ERB band');
    ylabel('dB');
    title('dB_{rms} of impulse responses and ERB difference (R channel)');

    handles.imp_out = [hout_L, hout_R];   % Combine left and right channel    
    
    
    C = round(0.0025 * handles.Fs); 
    [m, I] = max(abs(handles.imp_out));
    if (min(I) - C <= 0)
        handles.imp_out = [zeros(C-min(I)+1, 2); handles.imp_out];  
    end
    [m, I] = max(abs(handles.imp_out));
    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_orig = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_out(I+C+1:end,:) = (handles.imp_out(I+C+1:end,:)*DRR_orig)/handles.DRR; % Scale reverb for desired DRR;

    Direct = handles.imp_out(I-C: I+C, :); 
    Reverb = handles.imp_out(I+C+1: end, :);

    DRR_final = mean(rms(Direct))/mean(rms(Reverb)) %Find current DRR

    handles.imp_final_L = handles.imp_out(:, 1);
    handles.imp_final_R = handles.imp_out(:, 2);

    %% Compute IACC
    maxlags = round(0.001 * handles.Fs); % Maximum lag for correlation (cross head delay)
    [IACC] = max(abs(xcorr(handles.imp_final_L, handles.imp_final_R, maxlags, 'normalized' )))
    
    %normalise the output
    handles.imp_out = handles.imp_out ./ max(abs(handles.imp_out));
    
    N = length(handles.audio)+length(handles.imp_out)-1;	%confirm the length of FFT
    L = pow2(nextpow2(N));	%confirm the length of 2FFT
    X = fft(handles.audio,L);
    H = fft(handles.imp_out,L);
    Y = X .* H;
    handles.processed_audio = real(ifft(Y,L));		%get the output of the convolution
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
    
    disp(num2str(toc));
    
    plotFigure(handles.imp_out,handles.Fs) 
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < max([C1_Delay, C2_Delay, C3_Delay, C4_Delay, A1_Delay, A2_Delay]))
        power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
        power_of_2 = 10;
    end
    
    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(handles.imp_out)-1)/handles.Fs,length(handles.imp_out)),handles.imp_out);
    title('Schroeder impulse response');
    xlabel('Time (s)');
    ylabel('Amplitude');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('Schroeder filter');
    xlabel('Time (s)');
    ylabel('Amplitude');

    %return a frequency vector to give the x axis in Hz
    H = fft(handles.imp_out,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on  
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('Schroeder frequency response');
    xlabel('Frequency (Hz)');
    ylabel('Amplitude');
  
    %update handles  
    guidata(hObject, handles);

% --- Executes on button press in Play_processed_button.
function Play_processed_button_Callback(hObject, eventdata, handles)
% hObject    handle to Play_processed_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    sound(handles.processed_audio, handles.Fs);
    
function Save_path_Callback(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Save_path as text
%        str2double(get(hObject,'String')) returns contents of Save_path as a double
    handles.save = get(hObject, 'String');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Save_path_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Save_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end



function RT60_Callback(hObject, eventdata, handles)
% hObject    handle to RT60 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of RT60 as text
%        str2double(get(hObject,'String')) returns contents of RT60 as a double
    handles.RT60 = str2double(get(hObject, 'String'));
    if isnan(handles.RT60)
    errordlg('You must enter a numeric value','Bad Input','modal')
    end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function RT60_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RT60 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

% --- Executes on button press in Save_button.
function Save_button_Callback(hObject, eventdata, handles)
% hObject    handle to Save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    audiowrite(handles.save,handles.processed_audio,handles.Fs);
    guidata(hObject, handles);

% --- Executes on button press in Combined_comb_filter_button.
function Combined_comb_filter_button_Callback(hObject, eventdata, handles)
% hObject    handle to Combined_comb_filter_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    handles.C1_Delay = 0.0297;
    handles.C2_Delay = 0.0371;
    handles.C3_Delay = 0.0411;
    handles.C4_Delay = 0.0437;
    
    %calculate gains ('g') based on delay and RT60
    C1_gain=0.001^(handles.C1_Delay/handles.RT60);
    C2_gain=0.001^(handles.C2_Delay/handles.RT60);
    C3_gain=0.001^(handles.C3_Delay/handles.RT60);
    C4_gain=0.001^(handles.C4_Delay/handles.RT60);
    
    %convert combdelay value to samples
    C1_Delay = round(handles.C1_Delay * handles.Fs);
    C2_Delay = round(handles.C2_Delay * handles.Fs);
    C3_Delay = round(handles.C3_Delay * handles.Fs);
    C4_Delay = round(handles.C4_Delay * handles.Fs);
    
    %create impulse vector (set its length to RT60)
    imp=[1;zeros((handles.RT60 * handles.Fs),1)];
    
    %run 4 comb filters in parallel
    %using y[n] = x[n+T] + g.y[n + T]
    b = [zeros(C1_Delay,1);1];
    a = [1; zeros(C1_Delay-1,1); -C1_gain];
    %get impulse response
    imp_C1 = filter(b,a,imp);
    %filter input
    C1_out = filter(b,a,handles.audio);
    
    b = [zeros(C2_Delay,1);1];
    a = [1; zeros(C2_Delay-1,1); -C2_gain];
    %get impulse response
    imp_C2 = filter(b,a,imp);
    %filter input
    C2_out = filter(b,a,handles.audio);
    
    b = [zeros(C3_Delay,1);1];
    a = [1; zeros(C3_Delay-1,1); -C3_gain];
    %get impulse response
    imp_C3 = filter(b,a,imp);
    %filter input
    C3_out = filter(b,a,handles.audio);
    
    b = [zeros(C4_Delay,1);1];
    a = [1; zeros(C4_Delay-1,1); -C4_gain];
    %get impulse response
    imp_C4 = filter(b,a,imp);
    %filter input
    C4_out = filter(b,a,handles.audio);
    
    %sum outputs
    imp_comb = (imp_C1 * 0.25) + (imp_C2 * 0.25) + (imp_C3 * 0.25) + (imp_C4 * 0.25);
    handles.processed_audio = (C1_out * 0.25) + (C2_out * 0.25) + (C3_out * 0.25) + (C4_out * 0.25);

    %normalise filter output
    imp_comb = imp_comb ./ max(abs(imp_comb));
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
    
    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(imp_comb)-1)/handles.Fs,length(imp_comb)),imp_comb);
    title('parallel comb impulse response (x axis in s)');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('parallel comb filter only (x axis in s)');
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < max([C1_Delay, C2_Delay, C3_Delay, C4_Delay]))
    power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
    power_of_2 = 10;
    end
    
    %return a frequency vector to give the x axis in Hz
    H = fft(imp_comb,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('parallel comb frequency response (x axis in Hz)');
    
    %update handles  
    guidata(hObject, handles);

% --- Executes on button press in Combined_allpass_filter_button.
function Combined_allpass_filter_button_Callback(hObject, eventdata, handles)
% hObject    handle to Combined_allpass_filter_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    handles.A1_Delay = 0.005;
    handles.A2_Delay = 0.0017;
    
    handles.A1_RT60 = 0.09683;
    handles.A2_RT60 = 0.03292;
    
    %calculate gains ('g') based on delay and RT60
    A1_gain=0.001^(handles.A1_Delay/handles.A1_RT60);
    A2_gain=0.001^(handles.A2_Delay/handles.A2_RT60);
    
    %convert combdelay value to samples
    A1_Delay = round(handles.A1_Delay * handles.Fs);
    A2_Delay = round(handles.A2_Delay * handles.Fs);
    
    %create impulse vector (set its length to RT60)
    imp=[1;zeros(round(max([handles.A1_RT60,handles.A2_RT60]) * handles.Fs),1)];
    
    %set up the all pass filter as the following to use with 'filter'
    %y[n] = -g.x[n] + x[n+T] + g.y[n + T]
    b = [-A1_gain; zeros(A1_Delay-1,1);1];
    a = [1;zeros(A1_Delay-1,1); -A1_gain];
    %get impulse response
    imp_A1 = filter(b,a,imp);
    %filter audio
    handles.processed_audio = filter(b,a,handles.audio);
    
    b = [-A2_gain; zeros(A2_Delay-1,1);1];
    a = [1;zeros(A2_Delay-1,1); -A2_gain];
    %get impulse response
    imp_A2 = filter(b,a,imp_A1);
    %filter audio
    handles.processed_audio = filter(b,a,handles.processed_audio);
    
    %normalise filter output
    imp_A2 = imp_A2 ./ max(abs(imp_A2));
    handles.processed_audio = handles.processed_audio ./ max(abs(handles.processed_audio));
    
    %display impulse response
    axes(handles.Impulse_response); %set which axis to plot on
    plot(linspace(0,(length(imp_A2)-1)/handles.Fs,length(imp_A2)),imp_A2);
    title('Serial allpass impulse response (x axis in s)');
    
    %display processed waveform
    axes(handles.Processed_audio); %set which axes to plot on
    plot(linspace(0,(length(handles.processed_audio)-1)/handles.Fs,length(handles.processed_audio)),handles.processed_audio);
    title('Serial allpass filter only (x axis in s)');
    
    %calculate frequency response
    %set FFT size to be power of 2 which is greater than the length of a or b
    power_of_2=1;
    while ((2^power_of_2) < max([A1_Delay, A2_Delay]))
    power_of_2 = power_of_2 + 1;
    end
    % Calculate the frequncy spectrum for these filter coefficients ...
    % (Note that there could be aliasing if the FFT length is too small
    % with respect to the plotting number of points. Therefore need to
    % increase the length, which pads with zeros) but still a power of 2.
    if (power_of_2 < 10)
    power_of_2 = 10;
    end
    
    %return a frequency vector to give the x axis in Hz
    H = fft(imp_A2,2^power_of_2);
    %get magnitude of complex output
    gain = abs(H);
    
    %plot frequency response
    axes(handles.Frequency_response); %set which axis to plot on
    n = 0 : 2^power_of_2 - 1;
    F = n*handles.Fs/2^power_of_2;    %frequency sequence
    plot(F,gain);
    title('Serial allpass frequency response (x axis in Hz)');
    
    %update handles  
    guidata(hObject, handles);



function DRR_Callback(hObject, eventdata, handles)
% hObject    handle to DRR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DRR as text
%        str2double(get(hObject,'String')) returns contents of DRR as a double
handles.DRR = str2double(get(hObject,'string'));
if isnan(handles.DRR)
errordlg('You must enter a numeric value','Bad Input','modal')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function DRR_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DRR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
